import json
import os
import random
from datetime import datetime
# import FuncionesPDF

def crear_reporte(ruta_reporte):

    if(ruta_reporte == ''):
        try:
            os.mkdir('CarpetaReportes')
            ruta_reporte = 'CarpetaReportes'

        except OSError:
            pass

    num = random.randint(0, 20)
    now = datetime.now()

    months = ("Ene", "Feb", "Mar", "Abr", "May", "Jun", "Jul", "Ago", "Sep", "Oct", "Nov", "Dic")

    dia = str(now.day)
    mes = months[now.month - 1]
    año = str(now.year)
    hora = str(now.hour)
    minuto = str(now.minute)
    segundo = str(now.second)

    fecha = dia+mes+año+'-'+hora+'-'+minuto+'-'+segundo

    reporte = ruta_reporte + '\\Reporte'+str(num)+'-'+fecha+'.json'

    return reporte


def llenarReporte_Subentidad(reporte, opcion, id, cadena, valores_excel, valores_interfaz, subseccion):

    with open(reporte, 'r+') as json_file:
        diccionario = json.load(json_file)

        elementos = diccionario[opcion]

        for elemento in elementos:
            if elemento['ID'] == id :
                if 'Subseccion' in elemento:
                    subentidades = elemento['Subseccion']
                    # print(subentidades)
                    for subentidad in subentidades:
                        if subseccion in subentidad:
                            data = {
                                'Valores en excel': valores_excel,
                                'Valores en interfaz': valores_interfaz,
                                'Resultado': cadena
                            }
                            with open(reporte, 'r+') as file:
                                subentidad[subseccion].append(data)
                                file.seek(0)
                                json.dump(diccionario, file, indent=4)
                        else:
                            data = []
                            valores = {
                                'Valores en excel': valores_excel,
                                'Valores en interfaz': valores_interfaz,
                                'Resultado': cadena
                            }
                            data.append(valores)

                            with open(reporte, 'r+') as file:
                                subentidad[subseccion] = data
                                file.seek(0)
                                json.dump(diccionario, file, indent=4)

                else:
                    data = []
                    valores_subseccion = {
                            'Valores en excel': valores_excel,
                            'Valores en interfaz': valores_interfaz,
                            'Resultado': cadena
                        }
                    data.append(valores_subseccion)

                    data2 = []
                    valores = {
                        subseccion: data
                    }
                    data2.append(valores)

                    with open(reporte, 'r+') as file:
                        elemento['Subseccion'] = data2
                        file.seek(0)
                        json.dump(diccionario, file, indent=4)

def llenarReporte(reporte, opcion, cadena, valores_excel, valores_interfaz, id, estado_reporte):

    if estado_reporte != 'Terminado':
        existe = os.path.exists(reporte)
        if existe == True:

            with open(reporte, 'r+') as json_file:
                lista_opciones = json.load(json_file)

            if opcion in lista_opciones:
                data = {
                    'ID': id,
                    'Valores en excel': valores_excel,
                    'Valores en interfaz': valores_interfaz,
                    'Resultado': cadena
                }
                with open(reporte, 'r+') as file:
                    file_data = json.load(file)
                    file_data[opcion].append(data)
                    file.seek(0)
                    json.dump(file_data, file, indent=4)
            else:
                data = []
                valores = {
                        'ID': id,
                        'Valores en excel': valores_excel,
                        'Valores en interfaz': valores_interfaz,
                        'Resultado': cadena
                    }
                data.append(valores)

                with open(reporte, 'r+') as file:
                    file_data = json.load(file)
                    file_data[opcion] = data
                    file.seek(0)
                    json.dump(file_data, file, indent=4)
        else:
            data = {}
            data[opcion] = []
            data[opcion].append(
                {
                    'ID': id,
                    'Valores en excel': valores_excel,
                    'Valores en interfaz': valores_interfaz,
                    'Resultado': cadena
                }
            )
            with open(reporte, 'w') as file:
                json.dump(data, file, indent=4)

    # else:
    #     FuncionesPDF.GenerarReporte(reporte)


