import openpyxl

def fetch_number_of_columns(sheetname):
    sh = wk[sheetname]
    return sh.max_column

def fetch_number_of_rows(sheetname):
    sh = wk[sheetname]
    return sh.max_row

def fetch_cell_data(sheetname, row, col):
    sh = wk[sheetname]
    cell = sh.cell(int(row),int(col))
    return cell.value

# FUNCIONES PARA LAS TABLAS PRIMARIAS - ENTIDADES

def buscar_Opcion(sheetname, opcion):
    sh = wk[sheetname]
    nrows = sh.max_row
    ubicacion = ''

    for i in range(nrows):
        valor = fetch_cell_data(sheetname,i+1,1)
        valor2 = fetch_cell_data(sheetname,i+1,2)
        if(valor == 'Opción' and valor2 == opcion):
            ubicacion = (i+1)

    return ubicacion

def obtener_seccion(sheetname, ubicacion):
    seccion = fetch_cell_data(sheetname,ubicacion+1,2)
    return seccion

def search_location_range(sheetname, opcion, seccion):
    sh = wk[sheetname]
    nrows = sh.max_row
    fila_inicio = 0
    cant_filas = 0
    for i in range(3, nrows+1):
        valor_opcion = fetch_cell_data(sheetname,i,1)
        valor_seccion = fetch_cell_data(sheetname,i,2)

        if ((valor_opcion == opcion) & (((valor_seccion) == (seccion)))):
            if (fila_inicio == 0):
                    fila_inicio = i
            cant_filas += 1

    location = [fila_inicio,fila_inicio+cant_filas-1]

    return location

def traer_campos(sheetname,rango):
    lista_campos = []
    inicio = rango[0]
    fin = rango[1]

    for i in range(inicio, fin+1):
        valor = fetch_cell_data(sheetname, i, 3)
        lista_campos.append(valor)

    return lista_campos


def determinar_campos_opcion(opcion,seccion, tipo):
    if (tipo == 'seccion'):
        rango = search_location_range('Indice',opcion,seccion)
        campos = traer_campos('Indice',rango)
        return campos
    else:
        l = []
        for i in seccion:
            rango = search_location_range('Indice', opcion, i)
            campos = traer_campos('Indice', rango)
            l.append(campos)
        return l

def traer_ubicacion_campos(sheetname,rango):
    lista_campos = []
    inicio = rango[0]
    fin = rango[1]

    for i in range(inicio, fin + 1):
        identificador = fetch_cell_data(sheetname, i, 8)
        tipo = fetch_cell_data(sheetname, i, 9)
        campo = [identificador,tipo]
        lista_campos.append(campo)

    return lista_campos

def determinar_ubicacion_campos(opcion,seccion):
    rango = search_location_range('Indice',opcion,seccion)
    campos = traer_ubicacion_campos('Indice',rango)
    return campos

def obtener_tamaño_tabla(sheetname,ubicacion):
    cant = 0
    valor = '-'
    while(valor != None):
        valor = fetch_cell_data(sheetname,ubicacion + cant,1)
        if (valor != None):
            cant += 1
    return cant

def obtener_ubicacion_celdas(sheetname, fila):
    lista_ubicaciones = []
    ncol = fetch_number_of_columns(sheetname)
    for i in range(1, ncol+1):
        valor = fetch_cell_data(sheetname,fila,i)
        if (valor != None):
            lista_ubicaciones.append(i)

    return lista_ubicaciones

def obtener_valores_tabla(sheetname, fila, ubicacion):
    valores = []
    columnas = obtener_ubicacion_celdas(sheetname, ubicacion)
    for i in columnas:
        valor = fetch_cell_data(sheetname, fila, i)
        if (valor == None):
            valor = "-"
        valores.append(valor)

    return valores

def obtener_valores(ubicacion, sheetname):
    lista_valores = []
    tamaño_tabla = obtener_tamaño_tabla(sheetname, ubicacion + 3)
    for j in range(ubicacion + 3, ubicacion + 3 + tamaño_tabla):
        valores = obtener_valores_tabla(sheetname, j, ubicacion+2)
        lista_valores.append(valores)

    return lista_valores


def obtener_ubicacion_interfaz(sheetname,opcion):
    nrows = fetch_number_of_rows(sheetname)
    ncol = fetch_number_of_columns(sheetname)
    l = []
    for i in range(2,nrows+1):
        op = fetch_cell_data(sheetname,i,1)
        if(op == opcion):
            for j in range(3,ncol+1,2):
                valor = fetch_cell_data(sheetname,i,j)
                l.append(valor)
    return l

# FUNCIONES PARA TABLAS SECUNDARIAS - SUBENTIDADES

def buscar_tablas_Secundarias(sheetname):
    sh = wk[sheetname]
    location = []
    nrows = sh.max_row

    for i in range(nrows):
        valor = fetch_cell_data(sheetname,i+1,2)
        if (valor == 'Opción'):
            location.append(i+1)

    return location

def buscar_tabla_Secundaria(opcion,seccion, sheetname):
    list_location = buscar_tablas_Secundarias(sheetname)
    location = []

    for i in list_location:
        valor_opcion = fetch_cell_data(sheetname,i,4)
        valor_seccion = fetch_cell_data(sheetname,i+1,4)
        if ((valor_opcion == opcion) & (valor_seccion == seccion)):
            location.append(i)

    return location

def buscar_tabla_Secundaria2(opcion, tipo, sheetname):
    list_location = buscar_tablas_Secundarias(sheetname)
    location = []

    for i in list_location:
        valor_opcion = fetch_cell_data(sheetname,i,4)
        valor_tipo = fetch_cell_data(sheetname,i+2,4)
        if ((valor_opcion == opcion) & (valor_tipo == tipo)):
            location.append(i)

    return location



def obtener_lista_opciones_Sec(sheetname, ubicacion):
    opciones = []
    for i in ubicacion:
        opcion = fetch_cell_data(sheetname,i,4)
        opciones.append(opcion)
    return opciones

def obtener_secciones_Secundarias(opcion, sheetname):
    secciones = []
    ubicaciones = buscar_tablas_Secundarias(sheetname)
    for i in ubicaciones:
        valor_opcion = fetch_cell_data(sheetname,i,4)
        valor_seccion = fetch_cell_data(sheetname,i+1,4)
        if(valor_opcion == opcion):
            secciones.append(valor_seccion)
    return secciones


def obtener_tamaño_tabla_Sec(ubicacion, sheetname):
    cant = 0
    valor = '-'
    while(valor != None):
        valor = fetch_cell_data(sheetname,ubicacion + cant,2)
        if (valor != None):
            cant += 1
    return cant


def obtener_ubicacion_celdas_sec(sheetname, fila):
    lista_ubicaciones = []
    ncol = fetch_number_of_columns(sheetname)
    for i in range(2, ncol+1):
        valor = fetch_cell_data(sheetname,fila,i)
        if ((valor != None) and (valor != " ")):
            lista_ubicaciones.append(i)

    return lista_ubicaciones

def obtener_valores_tabla_Sec(sheetname, fila, ubicacion):
    valores = []
    columnas = obtener_ubicacion_celdas_sec(sheetname, ubicacion)
    for i in columnas:
        valor = fetch_cell_data(sheetname, fila, i)
        if (valor == None):
            valor = "-"
        valores.append(valor)

    return valores

def obtener_valores_Sec(ubicacion, sheetname):
    lista_valores = []
    for i in ubicacion:
        tamaño_tabla = obtener_tamaño_tabla_Sec(i + 3, sheetname)
        for j in range(i + 3, i + 3 + tamaño_tabla):
            valores = obtener_valores_tabla_Sec(sheetname, j, i+2)
            lista_valores.append(valores)

    return lista_valores

def obtener_valores_Sec_catalog(ubicacion, sheetname):
    lista_valores = []
    for i in ubicacion:
        tamaño_tabla = obtener_tamaño_tabla_Sec(i + 4, sheetname)
        for j in range(i + 4, i + 4 + tamaño_tabla):
            valores = obtener_valores_tabla_Sec(sheetname, j, i+3)
            lista_valores.append(valores)

    return lista_valores

def determinar_valores_subseccion(opcion, subsecciones,valores, sheetname):
    lista_valores = []

    if (opcion == 'Catalogos'):
        for i in valores:
            ubicacion = buscar_tabla_Secundaria2(opcion, i[2], sheetname)
            valores = obtener_valores_Sec_catalog(ubicacion, sheetname)
            lista_valores.append(valores)

    else:
        for i in subsecciones:
            ubicacion = buscar_tabla_Secundaria(opcion,i, sheetname)
            valores = obtener_valores_Sec(ubicacion, sheetname)
            lista_valores.append(valores)

    return lista_valores

def determinar_campos_subseccion(tipo, sheetname):
    nombres_campos = []
    ubicacion = buscar_tabla_Secundaria2('Catalogos',tipo, sheetname)
    for i in ubicacion:
        tipo_opcion = fetch_cell_data(sheetname,i+2,4)
        if (tipo_opcion == tipo):
            ncol = fetch_number_of_columns(sheetname)
            for j in range(3, ncol):
                valor = fetch_cell_data(sheetname,i+3,j)
                if (valor != None):
                    nombres_campos.append(valor)

    lista_campos = []
    for i in nombres_campos:
        if i != " ":
            lista_campos.append(i)

    return lista_campos

def obtener_campos_subseccion_catalogo(valores, sheetname):
    lista_campos = []

    for i in valores:
        lista = determinar_campos_subseccion(i[2], sheetname)
        lista_campos.append(lista)

    return lista_campos

def traer_ubicacion_campos_subseccion(sheetname,rango,nombres_campos):
    lista_campos = []
    inicio = rango[0]
    fin = rango[1]

    for j in nombres_campos:
        for i in range(inicio, fin + 1):
            valor_nombre_campo = fetch_cell_data(sheetname, i, 3)
            if (valor_nombre_campo == j):
                identificador = fetch_cell_data(sheetname, i, 8)
                tipo = fetch_cell_data(sheetname, i, 9)
                campo = [identificador,tipo]
                lista_campos.append(campo)

    return lista_campos

def determinar_ubicacion_campos_catalog(opcion,seccion,nombres_campos):
    rango = search_location_range('Indice',opcion,seccion)
    campos = traer_ubicacion_campos_subseccion('Indice',rango,nombres_campos)
    return campos

def obtener_ubicacion_campos_subseccion(opcion, subsecciones, campos):
    lista = []
    tam = len(subsecciones)
    for i in range(0, tam):
        if (opcion == 'Catalogos'):
            ubicaciones = determinar_ubicacion_campos_catalog(opcion,subsecciones[i],campos[i])
            lista.append(ubicaciones)
        else:
            ubicaciones = determinar_ubicacion_campos(opcion, subsecciones[i])
            lista.append(ubicaciones)

    return lista

# FUNCION PRINCIPAL
# SERA LA UNICA LLAMADA DE MANERA DIRECTA POR EL ROBOT

def llamar_datos_excel(opcion, ruta_excel,sheetname):
    global wk
    wk = openpyxl.load_workbook(ruta_excel)

    datos = []

    # OBTENER INFORMACION SOBRE LA TABLA PRIMARIA

    ubicacion = buscar_Opcion(sheetname,opcion)
    seccion = obtener_seccion(sheetname,ubicacion)
    ubicacion_interfaz = obtener_ubicacion_interfaz('Ubicacion',opcion)
    campos = determinar_campos_opcion(opcion, seccion, 'seccion')
    valores = obtener_valores(ubicacion, sheetname)
    ubicacion_campos_interfaz = determinar_ubicacion_campos(opcion, seccion)

    # OBTENER INFORMACION SOBRE LAS TABLAS SECUNDARIAS

    subsecciones = obtener_secciones_Secundarias(opcion, sheetname)
    longitud = len(subsecciones)
    if (longitud != 0):
        if (opcion == 'Catalogos'):
            campos_subsecciones = obtener_campos_subseccion_catalogo(valores, sheetname)
            valores_subsecciones = determinar_valores_subseccion(opcion,subsecciones,valores, sheetname)
            ubicacion_campos_subsecciones = obtener_ubicacion_campos_subseccion(opcion, subsecciones, campos_subsecciones)
        else:
            campos_subsecciones = determinar_campos_opcion(opcion, subsecciones, 'subseccion')
            valores_subsecciones = determinar_valores_subseccion(opcion,subsecciones,'', sheetname)
            ubicacion_campos_subsecciones = obtener_ubicacion_campos_subseccion(opcion, subsecciones, campos_subsecciones)
    else:
        campos_subsecciones = []
        valores_subsecciones = []
        ubicacion_campos_subsecciones = []

    # AÑADIR RESULTADOS A DATOS
    datos.append(seccion)
    datos.append(ubicacion)
    datos.append(ubicacion_interfaz)
    datos.append(campos)
    datos.append(valores)
    datos.append(ubicacion_campos_interfaz)
    datos.append(subsecciones)
    datos.append(campos_subsecciones)
    datos.append(valores_subsecciones)
    datos.append(ubicacion_campos_subsecciones)

    return datos


datos = llamar_datos_excel('Catalogos',
                           "D:\\DATOS 14 10 22\\Escritorio\\Proyectos y Trabajos personales\\Empresa BYTE\\ficheros ROBOT\\Configuracion_API_UATs.xlsx",
                           'Parametros')

print('Seccion: ' + str(datos[0]) +
      '\nUbicacion en Excel: ' + str(datos[1]) +
      '\nUbicacion en interfaz: ' + str(datos[2]) +
      '\nCampos: ' + str(datos[3]) +
      '\nValores: ' + str(datos[4]) +
      '\nUbicacion de campos en interfaz: ' + str(datos[5]) +
      '\nSubsecciones: ' + str(datos[6]) +
      '\nCampos de subsecciones: ' + str(datos[7]) +
      '\nValores de subsecciones: ' + str(datos[8]) +
      '\nUbicacion de campos de subsecciones en interfaz: ' + str(datos[9])+
      '\n')
#
a = buscar_tabla_Secundaria2('Catalogos','Tipo de catálogo básico','Parametros')
print("Tabla: "+ str(a))
b = obtener_valores_Sec_catalog(a,'Parametros')
print("valores: "+ str(b))