*** Settings ***
Library    RequestsLibrary
Library    JSONLibrary
Library    Collections
Library    SeleniumLibrary
Library    String

Library    ../FuncionesPython/FuncionesVarias.py


*** Keywords ***
Obtener ID - AJUSTES
    [Arguments]    ${header}    ${body}    ${session}    ${API}    ${item}

    ${id_response}=    post request    ${session}    ${API}    headers=${header}    data=${body}

    ${N_id_response}=    get length    ${id_response.content}

    IF    "${N_id_response}" != "0"
        ${id_response_string}=    convert to string    ${id_response.content}
#        log to console    CONTENIDO DEL RESPONSE EN STRING: ${id_response_string}
        ${id_response_string2}=    cambiarCaracterUTF8    ${id_response_string}
#        log to console    CONTENIDO DEL RESPONSE EN STRING DESPUES DE FUNCION: ${id_response_string2}
        ${id_json}=    convert string to json    ${id_response_string2}
#        log to console    CONTENIDO DEL RESPONSE EN JSON: ${id_json}
        @{value_data}=    get value from json    ${id_json}    data
#        log to console    DATA DEL JSON: ${value_data}
        ${n_value_data}=    get length    ${value_data}

        IF    "${n_value_data}" != "0"
            ${list}=    get from list    ${value_data}    0
        ELSE
            @{list}=    create list
        END

        ${N_LIST}=    get length    ${list}
        IF    "${N_LIST}" != "0"
            FOR    ${item1}    IN    @{list}
                @{value_agente}=    get value from json    ${item1}    partyName
                @{value_concept}=    get value from json    ${item1}    concept

                ${agente}=    get from list    ${value_agente}    0
                ${concepto}=    get from list    ${value_concept}    0

                IF    "${agente}"=="${item}[1]" and "${concepto}"=="${item}[5]"
                    @{value_id}=    get value from json    ${item1}    id
                    ${id}=    get from list    ${value_id}    0
                    BREAK
                ELSE
                    ${id}=    set variable    -
                END

            END
        ELSE
            ${id}=    set variable    -
        END
    ELSE
        ${id}=    set variable    -
    END

#    log to console    ${id}
    [return]    ${id}

Obtener_ID_PLANES
    [Arguments]    ${header}    ${body}    ${session}    ${API}

    ${id_response}=    post request    ${session}    ${API}    headers=${header}    data=${body}

    ${N_id_response}=    get length    ${id_response.content}

    IF    "${N_id_response}" != "0"
        ${id_response_string}=    convert to string    ${id_response.content}
#        log to console    CONTENIDO DEL RESPONSE EN STRING: ${id_response_string}
        ${id_response_string2}=    cambiarCaracterUTF8    ${id_response_string}
#        log to console    CONTENIDO DEL RESPONSE EN STRING DESPUES DE FUNCION: ${id_response_string2}
        ${id_json}=    convert string to json    ${id_response_string2}
#        log to console    CONTENIDO DEL RESPONSE EN JSON: ${id_json}
        @{value_data}=    get value from json    ${id_json}    data
#        log to console    DATA DEL JSON: ${value_data}
        ${list}=    get from list    ${value_data}    0
        ${list}=    get from list    ${list}    0
#        log to console    DATA DEL JSON (lista): ${list}

        @{valueID}=    get value from json    ${list}    id
        ${id}=    get from list    ${valueID}    0
        @{valueVERSION}=    get value from json    ${list}    version
        ${version}=    get from list    ${valueVERSION}    0



    ELSE
        ${id}=    set variable    -
        ${version}=    set variable    -
    END

    ${ID_VERSION}=    concatenar    ${id}    ${version}
    log to console    ID DEL PLAN: ${ID_VERSION}
    [return]    ${ID_VERSION}

Obtener ID - Current Version
    [Arguments]    ${header}    ${body}    ${session}    ${API}    ${valor}    ${opcion}

    ${id_response}=    post request    ${session}    ${API}    headers=${header}    data=${body}

    ${N_id_response}=    get length    ${id_response.content}

    IF    "${N_id_response}" != "0"
        ${id_response_string}=    convert to string    ${id_response.content}
#        log to console    CONTENIDO DEL RESPONSE EN STRING: ${id_response_string}
        ${id_response_string2}=    cambiarCaracterUTF8    ${id_response_string}
#        log to console    CONTENIDO DEL RESPONSE EN STRING DESPUES DE FUNCION: ${id_response_string2}
        ${id_json}=    convert string to json    ${id_response_string2}
#        log to console    CONTENIDO DEL RESPONSE EN JSON: ${id_json}
        @{value_data}=    get value from json    ${id_json}    data
#        log to console    DATA DEL JSON: ${value_data}
        ${n_value_data}=    get length    ${value_data}

        IF    "${n_value_data}" != "0"
            ${list}=    get from list    ${value_data}    0
        ELSE
            @{list}=    create list
        END

        ${N_LIST}=    get length    ${list}
        IF    "${N_LIST}" != "0"
            FOR    ${item}    IN    @{list}
                @{value}=    get value from json    ${item}    currentVersion.id
                IF    "${opcion}" == "Penalidades"
                    @{descripcion}=    get value from json    ${item}    description
                ELSE IF    "${opcion}" == "Excepciones"
                    @{descripcion}=    get value from json    ${item}    identifier
                END
                ${desc}=    get from list    ${descripcion}    0
                IF    "${desc}" == "${valor}"
                    ${id}=    get from list    ${value}    0
                    BREAK
                ELSE
                    ${id}=    set variable    -
                END
            END
        ELSE
            ${id}=    set variable    -
        END
    ELSE
        ${id}=    set variable    -
    END

#    log to console    ${id}
    [return]    ${id}

Obtener ID - Agreement Version
    [Arguments]    ${header}    ${body}    ${session}    ${API}    ${valor}

    ${id_response}=    post request    ${session}    ${API}    headers=${header}    data=${body}

    ${N_id_response}=    get length    ${id_response.content}

    IF    "${N_id_response}" != "0"
        ${id_response_string}=    convert to string    ${id_response.content}
#        log to console    CONTENIDO DEL RESPONSE EN STRING: ${id_response_string}
        ${id_response_string2}=    cambiarCaracterUTF8    ${id_response_string}
#        log to console    CONTENIDO DEL RESPONSE EN STRING DESPUES DE FUNCION: ${id_response_string2}
        ${id_json}=    convert string to json    ${id_response_string2}
#        log to console    CONTENIDO DEL RESPONSE EN JSON: ${id_json}
        @{value_data}=    get value from json    ${id_json}    data
#        log to console    DATA DEL JSON: ${value_data}
        ${n_value_data}=    get length    ${value_data}

        IF    "${n_value_data}" != "0"
            ${list}=    get from list    ${value_data}    0
        ELSE
            @{list}=    create list
        END

        ${N_LIST}=    get length    ${list}
        IF    "${N_LIST}" != "0"
            FOR    ${item}    IN    @{list}
                @{value}=    get value from json    ${item}    agreementVersion.id
                @{descripcion}=    get value from json    ${item}    agreementVersion.description
                ${desc}=    get from list    ${descripcion}    0
                IF    "${desc}" == "${valor}"
                    ${id}=    get from list    ${value}    0
                    BREAK
                ELSE
                    ${id}=    set variable    -
                END
            END
        ELSE
            ${id}=    set variable    -
        END
    ELSE
        ${id}=    set variable    -
    END

#    log to console    ID: ${id}
    [return]    ${id}


Obtener_ID
    [Arguments]    ${header}    ${body}    ${session}    ${API}

    ${id_response}=    post request    ${session}    ${API}    headers=${header}    data=${body}

    ${N_id_response}=    get length    ${id_response.content}

    IF    "${N_id_response}" != "0"
        ${id_response_string}=    convert to string    ${id_response.content}
#        log to console    CONTENIDO DEL RESPONSE EN STRING: ${id_response_string}
        ${id_response_string2}=    cambiarCaracterUTF8    ${id_response_string}
#        log to console    CONTENIDO DEL RESPONSE EN STRING DESPUES DE FUNCION: ${id_response_string2}
        ${id_json}=    convert string to json    ${id_response_string2}
#        log to console    CONTENIDO DEL RESPONSE EN JSON: ${id_json}
        @{value_data}=    get value from json    ${id_json}    data
#        log to console    DATA DEL JSON: ${value_data}
        ${n_value_data}=    get length    ${value_data}

        IF    "${n_value_data}" != "0"
            ${list}=    get from list    ${value_data}    0
        ELSE
            @{list}=    create list
        END

        ${N_LIST}=    get length    ${list}
        IF    "${N_LIST}" != "0"
            FOR    ${item}    IN    @{list}
                @{value}=    get value from json    ${item}    id
                ${id}=    get from list    ${value}    0
                BREAK
            END
        ELSE
            ${id}=    set variable    -
        END
    ELSE
        ${id}=    set variable    -
    END

#    log to console    ${id}
    [return]    ${id}

Obtener data - calendario excepciones
    [Arguments]    ${header}    ${body}    ${session}    ${API}    ${ID}

    IF    ("${ID}" == "-") or ("${ID}" == "-&-")
        ${valores}=    set variable    -
    ELSE
        ${response}=    post request    ${session}    ${API}    headers=${header}    data=${body}

        ${N_response}=    get length    ${response.content}
        ${tipo}=    mostrar tipo    ${response.content}
#        log to console    TAMAÑO: ${N_response} || TIPO: ${tipo}

        IF    "${N_response}" != "0"
            ${response_string}=    convert to string    ${response.content}
#            log to console    CONTENIDO DEL RESPONSE EN STRING: ${response_string}
            ${lista_value_data}=    cambiarCaracterUTF8    ${response_string}
            ${lista_value_data}=    quitar corchetes    ${lista_value_data}
            @{value_data}=    split string    ${lista_value_data}    "delete":false},{"id"
#            log to console    DATA DEL JSON: ${value_data}
            ${n_value_data}=    get length    ${value_data}
#            log to console    ${n_value_data}


            ${N_LIST}=    get length    ${value_data}
            IF    "${N_LIST}" != "0"
                @{valores}=    create list
                FOR    ${i}    IN RANGE    0    ${N_LIST}
                    ${n}=    sumar    ${i}    1
                    IF    ("${i}" != "0") and ("${n}" != "${N_LIST}")
                        ${VALOR_DATA}=    concatenar2    {"id"    ${value_data}[${i}]
                        ${VALOR_DATA}=    concatenar2    ${VALOR_DATA}    "delete":false}
                    ELSE IF    "${i}" == "0"
                        ${VALOR_DATA}=    concatenar2    ${value_data}[${i}]    "delete":false}
                    ELSE
                        ${VALOR_DATA}=    concatenar2    {"id"    ${value_data}[${i}]
                    END

                    ${valor_json}=    convert string to json    ${VALOR_DATA}
                    @{ID_CALENDARIO}=    get value from json    ${valor_json}    calendar.id
                    ${id_cal}=    get from list    ${ID_CALENDARIO}    0
                    IF    "${id_cal}" == "${ID}"
#                        log to console    ITEM: ${valor_json}
                        append to list    ${valores}    ${valor_json}
                    END
                END

                ${n_valores}=    get length    ${valores}
                IF    "${valores}" == "0"
                    ${valores}=    set variable    -
                END

            ELSE
                ${valores}=    set variable    -
            END
        ELSE
            ${valores}=    set variable    -
        END
    END

#    log to console    ${valores}
    [return]    ${valores}

Obtener data
    [Arguments]    ${header}    ${ID}    ${session}    ${API}

    IF    ("${ID}" == "-") or ("${ID}" == "-&-")
        ${valor_json}=    set variable    -
    ELSE
        ${valor}=    get request    ${session}    ${API}/${ID}    headers=${header}
        ${valor_string}=    convert to string    ${valor.content}
        log to console    CONTENIDO DEL VALOR EN STRING: ${valor_string}
        ${valor_string2}=    cambiarCaracterUTF8    ${valor_string}
        log to console    CONTENIDO DEL VALOR EN STRING DESPUES DE FUNCION: ${valor_string2}
        ${valor_json}=    convert string to json    ${valor_string2}
        log to console    CONTENIDO DEL VALOR EN JSON: ${valor_json}

    END
    [return]    ${valor_json}

Obtener data - condicion intervalos
    [Arguments]    ${header}    ${ID}    ${session}    ${API}    ${body}

    log to console    ${API}
    IF    ("${ID}" == "-") or ("${ID}" == "-&-")
        ${valor_json1}=    set variable    -
    ELSE
        ${valor}=    post request    ${session}    ${API}    headers=${header}    data=${body}
        ${valor_string}=    convert to string    ${valor.content}
#        log to console    CONTENIDO DEL VALOR EN STRING: ${valor_string}
        ${valor_string2}=    cambiarCaracterUTF8    ${valor_string}
#        log to console    CONTENIDO DEL VALOR EN STRING DESPUES DE FUNCION: ${valor_string2}
        ${valor_json}=    convert string to json    ${valor_string2}
#        log to console    CONTENIDO DEL VALOR EN JSON: ${valor_json}
        @{value_data}=    get value from json    ${valor_json}    data

        ${n_value_data}=    get length    ${value_data}

        IF    "${n_value_data}" != "0"
            ${valor_json1}=    get from list    ${value_data}    0
        ELSE
            @{valor_json1}=    set variable    -
        END


    END
    [return]    ${valor_json1}

Obtener data - tipo cambio
    [Arguments]    ${header}    ${body}    ${session}    ${API}    ${item}

    ${fecha_excel}=    change format date2    ${item}[3]

    ${response}=    post request    ${session}    ${API}    headers=${header}    data=${body}

    ${Nresponse}=    get length    ${response.content}

    IF    "${Nresponse}" != "0"
        ${id_response_string}=    convert to string    ${response.content}
#        log to console    CONTENIDO DEL RESPONSE EN STRING: ${id_response_string}
        ${id_response_string2}=    cambiarCaracterUTF8    ${id_response_string}
#        log to console    CONTENIDO DEL RESPONSE EN STRING DESPUES DE FUNCION: ${id_response_string2}
        ${id_json}=    convert string to json    ${id_response_string2}
#        log to console    CONTENIDO DEL RESPONSE EN JSON: ${id_json}
        @{value_data}=    get value from json    ${id_json}    data
#        log to console    DATA DEL JSON: ${value_data}
        ${n_value_data}=    get length    ${value_data}

        IF    "${n_value_data}" != "0"
            ${list}=    get from list    ${value_data}    0
        ELSE
            @{list}=    create list
        END

        ${N_LIST}=    get length    ${list}
        IF    "${N_LIST}" != "0"
            FOR    ${item_json}    IN    @{list}
#                log to console    DATOS: ${item_json}
                ${fecha}=    get value from json    ${item_json}    startDate
#                log to console    FECHA: ${fecha}
#                log to console    FECHA EXCEL: ${fecha_excel}
                IF      "${fecha}[0]" == "${fecha_excel}"
                    ${valores}=    set variable    ${item_json}
                    BREAK
                ELSE
                    ${valores}=    set variable    -
                END
            END
        ELSE
            ${valores}=    set variable    -
        END
    ELSE
        ${valores}=    set variable    -
    END

#    log to console    ${valores}
    [return]    ${valores}

Obtener data - catalogos
    [Arguments]    ${header}    ${body}    ${ID}    ${session}    ${API}

    IF    ("${ID}" == "-")
        ${valor_json}=    set variable    -
    ELSE
        ${valor}=    post request    ${session}    ${API}/${ID}    headers=${header}    data=${body}
        ${valor_string}=    convert to string    ${valor.content}
        log to console    CONTENIDO DEL VALOR EN STRING: ${valor_string}
        ${valor_string2}=    cambiarCaracterUTF8    ${valor_string}
        log to console    CONTENIDO DEL VALOR EN STRING DESPUES DE FUNCION: ${valor_string2}
    #    ${valor_string3}=    convert to string    ${valor_string2}
        ${valor_json}=    convert string to json    ${valor_string2}
#        log to console    CONTENIDO DEL VALOR EN JSON: ${valor_json}
        @{value_data}=    get value from json    ${valor_json}    data
#        log to console    ${value_data}
    END
    [return]    ${value_data}

