*** Settings ***
Library    RequestsLibrary
Library    JSONLibrary
Library    Collections
Library    SeleniumLibrary

Library    ../FuncionesPython/FuncionesVarias.py
Resource    FuncionesVarias.robot
Resource    FuncionesActualizacion.robot

*** Keywords ***
Validar subentidad
    [Arguments]    ${opcion}    ${item}    ${datos_API}    ${data_excel}    ${flag_reporte}    ${reporte}    ${valores_subentidades_API_externa}    ${ID}

    log to console    || EMPEZANDO VALIDACION DE SUBENTIDADES ||

    ${subsecciones}=    get from list    ${data_excel}    6
    ${n_subsecciones}=    get length    ${subsecciones}

    IF    "${opcion}" != "Catalogos"
        FOR    ${i}    IN RANGE    0    ${n_subsecciones}
            ${campos_subseccion}=    traer campos subseccion de lista    ${data_excel}    ${i}
            ${valores_subseccion}=    traer valores subseccion de lista    ${data_excel}    ${i}    ${item}[0]
            ${ubicacion_campos_subseccion}=    traer ubicacion campos subseccion de lista    ${data_excel}    ${i}
            ${tam_subseccion}=    GET LENGTH    ${valores_subseccion}
            ${tipo_identificador}=    obtener tipo de identificador    ${opcion}    ${subsecciones}[${i}]

#            Validar configuracion - subentidad    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}

            IF    "${opcion}"=="Calendario"
                IF    "${subsecciones}[${i}]"=="Dia de Semana"
                    Validar configuracion - dia de semana    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}
                ELSE IF    "${subsecciones}[${i}]"=="Excepciones"
                    Validar configuracion - excepciones    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}    ${valores_subentidades_API_externa}
                END
            ELSE IF    "${opcion}"=="Intervalo"
                IF    "${subsecciones}[${i}]"=="Condicion"
                    Validar configuracion - condicion intervalo    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}        ${valores_subentidades_API_externa}
                ELSE IF    "${subsecciones}[${i}]"=="Rango"
                    Validar configuracion - rango intervalo    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}    ${valores_subentidades_API_externa}
                END
            ELSE IF    ("${opcion}"=="Matriz de puntos") and ("${subsecciones}[${i}]"=="Distribucion de puntos")
                Validar configuracion - dist puntos    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}

            ELSE IF    ("${opcion}"=="Excepciones") and ("${subsecciones}[${i}]"=="Tipo de excepciones - Rango")
                Validar configuracion - rango excepciones    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}

            ELSE IF    "${opcion}"=="Acuerdos"
                IF    ("${subsecciones}[${i}]"=="Roles comisionistas") or ("${subsecciones}[${i}]"=="Oferta comercial")
                    Validar configuracion - oferta y rol acuerdo    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}        ${valores_subentidades_API_externa}
                ELSE IF    "${subsecciones}[${i}]"=="Asignacion de metas por criterios"
                    Validar configuracion - asignacion acuerdo    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}    ${valores_subentidades_API_externa}
                END
            ELSE IF    ("${opcion}"=="Insumos") and ("${subsecciones}[${i}]"=="Detalle de fichero - campos")
                Validar configuracion - campos ficheros    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}

            ELSE IF    ("${opcion}"=="Estructura de Comisión")
                IF    ("${subsecciones}[${i}]"=="Comision periodica - Oferta comercial") or ("${subsecciones}[${i}]"=="Comision periodica - Origen de comision") or ("${subsecciones}[${i}]"=="Distribucion - Pago Condicionado") or ("${subsecciones}[${i}]"=="Distribucion - Clawback")
                    Validar configuracion - distribucion y com periodica    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}
                ELSE IF    ("${subsecciones}[${i}]"=="Condiciones Alteran Distribución")
                    Validar configuracion - estructura condiciones alteracion    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}
                ELSE IF    ("${subsecciones}[${i}]"=="Rangos")
                    Validar configuracion - estructura rangos    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}
                ELSE
                    Validar configuracion - subentidad    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}    ${ID}
                END
            ELSE
                Validar configuracion - subentidad    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subsecciones}[${i}]    ${flag_reporte}    ${reporte}    ${ID}
            END
        END
    ELSE
        ${lista_valores_subseccion}=    get from list    ${data_excel}    8
        ${lista_valores_subseccion}=    get from list    ${lista_valores_subseccion}    0
        ${n_lista}=    get length    ${lista_valores_subseccion}
        log to console    ${n_lista}


        ${campos_subseccion}=    traer campos subseccion de lista    ${data_excel}    0
        ${valores_subseccion}=    traer valores subseccion de lista    ${data_excel}    0    ${item}[0]
        ${ubicacion_campos_subseccion}=    traer ubicacion campos subseccion de lista    ${data_excel}    0
        ${tam_subseccion}=    GET LENGTH    ${valores_subseccion}
        ${tipo_identificador}=    obtener tipo de identificador    ${opcion}    Elemento

#        log to console    ${campos_subseccion}
#        log to console    ${valores_subseccion}
#        log to console    ${ubicacion_campos_subseccion}
#        log to console    ${tipo_identificador}

        Validar configuracion - catalogos    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    Elemento    ${flag_reporte}    ${reporte}    ${valores_subentidades_API_externa}

    END

Validar configuracion - estructura rangos
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}

    log to console    VALIDANDO ${subseccion}
    ${N_CAMPOS}=    get length    ${campos_subseccion}
    ${tipo_identificador2}=    obtener tipo de identificador2    ${opcion}    ${subseccion}

#    FOR    ${i}    IN RANGE    0    1
    FOR    ${i}    IN RANGE    0    ${tam_subseccion}

        ${valores_excel}=    get from list    ${valores_subseccion}    ${i}
        ${identificador1}=    obtener identificador subentidad    ${opcion}    ${subseccion}    ${valores_excel}
        ${identificador2}=    obtener identificador2 subentidad    ${opcion}    ${subseccion}    ${valores_excel}

        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list

        FOR    ${j}    IN RANGE    0    ${N_CAMPOS}
            ${n}=    sumar    ${j}    1
            ${valor}=    set variable    -

#            log to console    CAMPO ACTUAL: ${campos_subseccion}[${j}]

            @{Lista_ubicacion}=    separarRutaJSON    ${ubicacion_campos_subseccion}[${j}][0]
#            log to console    ${Lista_ubicacion}
            ${N_LISTA}=    get length    ${Lista_ubicacion}

            @{Valores}=    get value from json    ${datos_API}    ${Lista_ubicacion}[0]
#            log to console    Valores del planConceptList: ${Valores}
            ${Valores}=    get from list    ${Valores}    0
            ${N_VALORES}=    get length    ${Valores}
#            log to console    GRUPO DE VALORES: ${Valores}
            ${encontrado}=    set variable    No
            ${encontrado_solo_tipo}=    set variable    No

            FOR    ${k}    IN RANGE    0    ${N_VALORES}
                IF    "${encontrado}" == "No"
                    ${estado}=    run keyword and return status    get from list    ${Valores}    ${k}
                    IF    "${estado}"=="True"
                        ${valor1}=    get from list    ${Valores}    ${k}
                    ELSE
                        ${valor1}=    set variable    ${Valores}
                    END
#                    log to console    VALOR: ${valor1}
                    ${N_VALORES1}=    get length    ${valor1}

                    ${IDENTIFICADOR_JSON}=    get value from json    ${valor1}    ${tipo_identificador}
#                    log to console    IDENTIFICADOR: ${IDENTIFICADOR_JSON}
                    ${tam_ident}=    get length    ${IDENTIFICADOR_JSON}

                    IF    "${tam_ident}" != "0"
                        IF    "${identificador1}" == "${IDENTIFICADOR_JSON}[0]"
                            @{Valores2}=    get value from json    ${valor1}    ${Lista_ubicacion}[1]
    #                        log to console    ${Valores2}
                            ${estado2}=    run keyword and return status    get from list    ${Valores2}    0
                            IF    ("${campos_subseccion}[${j}]" == "Valor Minimo") or ("${campos_subseccion}[${j}]" == "Valor Maximo")
                                IF    "${estado2}"=="True"
                                    ${valor}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor}=    set variable    ${Valores2}
                                END
#                                log to console    ${valor}
                                ${encontrado}=    set variable    Si
                                ${encontrado_solo_tipo}=    set variable    Si

                            ELSE
                                IF    "${estado2}"=="True"
                                    ${valor2}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor2}=    set variable    ${Valores2}
                                END
                                ${N_VALORES2}=    get length    ${valor2}

                                FOR    ${p}    IN RANGE    0    ${N_VALORES2}
                                    IF    "${encontrado}" == "No"
                                        ${JSON_Valores3}=    get from list    ${valor2}    ${p}
#                                           log to console    VALOR DEL JSON: ${JSON_Valores3}
                                        ${IDENTIFICADOR_JSON2}=    get value from json    ${JSON_Valores3}    ${tipo_identificador2}
#                                        log to console    IDENTIFICADOR 2: ${IDENTIFICADOR_JSON}
                                        ${tam_ident2}=    get length    ${IDENTIFICADOR_JSON2}

                                        ${IDENTIFICADOR_JSON2}=    get from list    ${IDENTIFICADOR_JSON2}    0

                                        IF    "${tam_ident2}" != "0"
                                            IF    "${identificador2}" == "${IDENTIFICADOR_JSON2}"
                                                @{Valores3}=    get value from json    ${JSON_Valores3}    ${Lista_ubicacion}[2]
#                                                            log to console    ${Valores3}
                                                ${estado3}=    run keyword and return status    get from list    ${Valores3}    0
                                                IF    "${estado3}"=="True"
                                                    ${valor}=    get from list    ${Valores3}    0
                                                ELSE
                                                    ${valor}=    set variable    ${Valores3}
                                                END
#                                                    log to console    VALOR: ${valor}
                                                ${encontrado}=    set variable    Si
                                                ${encontrado_solo_tipo}=    set variable    Otros
                                            END
                                        END
                                    END
                                END
                            END
                        END
                    END
                END
            END

            ${test}=    set variable    -
#            log to console    VALOR DE SUBENTIDAD: ${valor}

            IF    "${encontrado}" == "Si"
                @{lista_valor_excel}=    get from list    ${valores_subseccion}    ${i}
                ${valor_excel}=    get from list    ${lista_valor_excel}    ${n}
                ${valor_excel}=    modificar si es fecha    ${valor_excel}
#                log to console    VALOR DEL EXCEL: ${valor_excel}
                ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valores_subseccion}[${i}][${n}]

                IF    "${esta_vacio}" != "False"
                    IF    """${valor}""" != """${valor_excel}"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    ${valor}
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                ELSE
                    IF    """${valor_excel}""" != """-"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    -
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                END
            END
        END

        ${N_LISTA}=    get length    ${lista_campos_diferentes}
        IF    "${N_LISTA}" != "0"
            ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
            realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

        ELSE
            IF    "${encontrado_solo_tipo}" == "Otros"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            ELSE
                ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][1]
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            END
        END

    END


Validar configuracion - distribucion y com periodica
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}

    log to console    VALIDANDO ${subseccion}
    ${N_CAMPOS}=    get length    ${campos_subseccion}
    ${tipo_identificador2}=    obtener tipo de identificador2    ${opcion}    ${subseccion}

#    FOR    ${i}    IN RANGE    0    1
    FOR    ${i}    IN RANGE    0    ${tam_subseccion}

        ${valores_excel}=    get from list    ${valores_subseccion}    ${i}
        ${identificador1}=    obtener identificador subentidad    ${opcion}    ${subseccion}    ${valores_excel}
        ${identificador2}=    obtener identificador2 subentidad    ${opcion}    ${subseccion}    ${valores_excel}

        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list

        FOR    ${j}    IN RANGE    0    ${N_CAMPOS}
            ${n}=    sumar    ${j}    1
            ${valor}=    set variable    -

#            log to console    CAMPO ACTUAL: ${campos_subseccion}[${j}]

            @{Lista_ubicacion}=    separarRutaJSON    ${ubicacion_campos_subseccion}[${j}][0]
#            log to console    ${Lista_ubicacion}
            ${N_LISTA}=    get length    ${Lista_ubicacion}

            @{Valores}=    get value from json    ${datos_API}    ${Lista_ubicacion}[0]
#            log to console    Valores del planConceptList: ${Valores}
            ${Valores}=    get from list    ${Valores}    0
            ${N_VALORES}=    get length    ${Valores}
#            log to console    GRUPO DE VALORES: ${Valores}
            ${encontrado}=    set variable    No
            ${encontrado_solo_tipo}=    set variable    No

            FOR    ${k}    IN RANGE    0    ${N_VALORES}
                IF    "${encontrado}" == "No"
                    ${estado}=    run keyword and return status    get from list    ${Valores}    ${k}
                    IF    "${estado}"=="True"
                        ${valor1}=    get from list    ${Valores}    ${k}
                    ELSE
                        ${valor1}=    set variable    ${Valores}
                    END
#                    log to console    VALOR: ${valor1}
                    ${N_VALORES1}=    get length    ${valor1}

                    ${IDENTIFICADOR_JSON}=    get value from json    ${valor1}    ${tipo_identificador}
#                    log to console    IDENTIFICADOR: ${IDENTIFICADOR_JSON}
                    ${tam_ident}=    get length    ${IDENTIFICADOR_JSON}

                    IF    "${tam_ident}" != "0"
                        IF    "${identificador1}" == "${IDENTIFICADOR_JSON}[0]"
                            @{Valores2}=    get value from json    ${valor1}    ${Lista_ubicacion}[1]
    #                        log to console    ${Valores2}
                            ${estado2}=    run keyword and return status    get from list    ${Valores2}    0
                            IF    ("${campos_subseccion}[${j}]" == "Periodo")
                                IF    "${estado2}"=="True"
                                    ${valor}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor}=    set variable    ${Valores2}
                                END
#                                log to console    ${valor}
                                ${encontrado}=    set variable    Si
                                ${encontrado_solo_tipo}=    set variable    Si

                            ELSE
                                IF    "${estado2}"=="True"
                                    ${valor2}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor2}=    set variable    ${Valores2}
                                END
                                ${N_VALORES2}=    get length    ${valor2}

                                FOR    ${p}    IN RANGE    0    ${N_VALORES2}
                                    IF    "${encontrado}" == "No"
                                        ${JSON_Valores3}=    get from list    ${valor2}    ${p}
#                                           log to console    VALOR DEL JSON: ${JSON_Valores3}
                                        ${IDENTIFICADOR_JSON2}=    get value from json    ${JSON_Valores3}    ${tipo_identificador2}
#                                        log to console    IDENTIFICADOR 2: ${IDENTIFICADOR_JSON}
                                        ${tam_ident2}=    get length    ${IDENTIFICADOR_JSON2}

                                        ${IDENTIFICADOR_JSON2}=    get from list    ${IDENTIFICADOR_JSON2}    0

                                        IF    "${tam_ident2}" != "0"
                                            IF    "${identificador2}" == "${IDENTIFICADOR_JSON2}"
                                                @{Valores3}=    get value from json    ${JSON_Valores3}    ${Lista_ubicacion}[2]
#                                                            log to console    ${Valores3}
                                                ${estado3}=    run keyword and return status    get from list    ${Valores3}    0
                                                IF    "${estado3}"=="True"
                                                    ${valor}=    get from list    ${Valores3}    0
                                                ELSE
                                                    ${valor}=    set variable    ${Valores3}
                                                END
#                                                    log to console    VALOR: ${valor}
                                                ${encontrado}=    set variable    Si
                                                ${encontrado_solo_tipo}=    set variable    Otros
                                            END
                                        END
                                    END
                                END
                            END
                        END
                    END
                END
            END

            ${test}=    set variable    -
#            log to console    VALOR DE SUBENTIDAD: ${valor}

            IF    "${encontrado}" == "Si"
                @{lista_valor_excel}=    get from list    ${valores_subseccion}    ${i}
                ${valor_excel}=    get from list    ${lista_valor_excel}    ${n}
                ${valor_excel}=    modificar si es fecha    ${valor_excel}
#                log to console    VALOR DEL EXCEL: ${valor_excel}
                ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valores_subseccion}[${i}][${n}]

                IF    "${esta_vacio}" != "False"
                    IF    """${valor}""" != """${valor_excel}"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    ${valor}
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                ELSE
                    IF    """${valor_excel}""" != """-"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    -
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                END
            END
        END

        ${N_LISTA}=    get length    ${lista_campos_diferentes}
        IF    "${N_LISTA}" != "0"
            ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][2] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
            realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

        ELSE
            IF    "${encontrado_solo_tipo}" == "Otros"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][2] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            ELSE
                ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][2]
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            END
        END

    END


Validar configuracion - estructura condiciones alteracion
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}

    log to console    VALIDANDO ${subseccion}
    ${N_CAMPOS}=    get length    ${campos_subseccion}
    ${tipo_identificador2}=    obtener tipo de identificador2    ${opcion}    ${subseccion}

#    FOR    ${i}    IN RANGE    0    1
    FOR    ${i}    IN RANGE    0    ${tam_subseccion}

        ${valores_excel}=    get from list    ${valores_subseccion}    ${i}
        ${identificador1}=    obtener identificador subentidad    ${opcion}    ${subseccion}    ${valores_excel}
        ${identificador2}=    obtener identificador2 subentidad    ${opcion}    ${subseccion}    ${valores_excel}

        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list

        FOR    ${j}    IN RANGE    0    ${N_CAMPOS}
            ${n}=    sumar    ${j}    1
            ${valor}=    set variable    -

#            log to console    CAMPO ACTUAL: ${campos_subseccion}[${j}]

            @{Lista_ubicacion}=    separarRutaJSON    ${ubicacion_campos_subseccion}[${j}][0]
#            log to console    ${Lista_ubicacion}
            ${N_LISTA}=    get length    ${Lista_ubicacion}

            @{Valores}=    get value from json    ${datos_API}    ${Lista_ubicacion}[0]
#            log to console    Valores del planConceptList: ${Valores}
            ${Valores}=    get from list    ${Valores}    0
            ${N_VALORES}=    get length    ${Valores}
#            log to console    GRUPO DE VALORES: ${Valores}
            ${encontrado}=    set variable    No
            ${encontrado_solo_tipo}=    set variable    No

            FOR    ${k}    IN RANGE    0    ${N_VALORES}
                IF    "${encontrado}" == "No"
                    ${estado}=    run keyword and return status    get from list    ${Valores}    ${k}
                    IF    "${estado}"=="True"
                        ${valor1}=    get from list    ${Valores}    ${k}
                    ELSE
                        ${valor1}=    set variable    ${Valores}
                    END
#                    log to console    VALOR: ${valor1}
                    ${N_VALORES1}=    get length    ${valor1}

                    ${IDENTIFICADOR_JSON}=    get value from json    ${valor1}    ${tipo_identificador}
#                    log to console    IDENTIFICADOR: ${IDENTIFICADOR_JSON}
                    ${tam_ident}=    get length    ${IDENTIFICADOR_JSON}

                    IF    "${tam_ident}" != "0"
                        IF    "${identificador1}" == "${IDENTIFICADOR_JSON}[0]"
                            @{Valores2}=    get value from json    ${valor1}    ${Lista_ubicacion}[1]
    #                        log to console    ${Valores2}
                            ${estado2}=    run keyword and return status    get from list    ${Valores2}    0
                            IF    ("${campos_subseccion}[${j}]" == "Valor Minimo") or ("${campos_subseccion}[${j}]" == "Valor Maximo")
                                IF    "${estado2}"=="True"
                                    ${valor}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor}=    set variable    ${Valores2}
                                END
#                                log to console    ${valor}
                                ${encontrado}=    set variable    Si
                                ${encontrado_solo_tipo}=    set variable    Si

                            ELSE
                                IF    "${estado2}"=="True"
                                    ${valor2}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor2}=    set variable    ${Valores2}
                                END
                                ${N_VALORES2}=    get length    ${valor2}

                                FOR    ${p}    IN RANGE    0    ${N_VALORES2}
                                    IF    "${encontrado}" == "No"
                                        ${JSON_Valores3}=    get from list    ${valor2}    ${p}
#                                           log to console    VALOR DEL JSON: ${JSON_Valores3}
                                        ${IDENTIFICADOR_JSON2}=    get value from json    ${JSON_Valores3}    ${tipo_identificador2}
#                                        log to console    IDENTIFICADOR 2: ${IDENTIFICADOR_JSON}
                                        ${tam_ident2}=    get length    ${IDENTIFICADOR_JSON2}

                                        ${IDENTIFICADOR_JSON2}=    get from list    ${IDENTIFICADOR_JSON2}    0

                                        IF    "${tam_ident2}" != "0"
                                            IF    "${identificador2}" == "${IDENTIFICADOR_JSON2}"
                                                @{Valores3}=    get value from json    ${JSON_Valores3}    ${Lista_ubicacion}[2]
#                                                            log to console    ${Valores3}
                                                ${estado3}=    run keyword and return status    get from list    ${Valores3}    0
                                                IF    "${estado3}"=="True"
                                                    ${valor}=    get from list    ${Valores3}    0
                                                ELSE
                                                    ${valor}=    set variable    ${Valores3}
                                                END
#                                                    log to console    VALOR: ${valor}
                                                ${encontrado}=    set variable    Si
                                                ${encontrado_solo_tipo}=    set variable    Otros
                                            END
                                        END
                                    END
                                END
                            END
                        END
                    END
                END
            END

            ${test}=    set variable    -
#            log to console    VALOR DE SUBENTIDAD: ${valor}

            IF    "${encontrado}" == "Si"
                @{lista_valor_excel}=    get from list    ${valores_subseccion}    ${i}
                ${valor_excel}=    get from list    ${lista_valor_excel}    ${n}
                ${valor_excel}=    modificar si es fecha    ${valor_excel}
#                log to console    VALOR DEL EXCEL: ${valor_excel}
                ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valores_subseccion}[${i}][${n}]

                IF    "${esta_vacio}" != "False"
                    IF    """${valor}""" != """${valor_excel}"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    ${valor}
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                ELSE
                    IF    """${valor_excel}""" != """-"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    -
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                END
            END
        END

        ${N_LISTA}=    get length    ${lista_campos_diferentes}
        IF    "${N_LISTA}" != "0"
            ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][2] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
            realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

        ELSE
            IF    "${encontrado_solo_tipo}" == "Otros"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][2] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            ELSE
                ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][2]
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            END
        END

    END


Validar configuracion - campos ficheros
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}

    log to console    VALIDANDO ${subseccion}
    ${N_CAMPOS}=    get length    ${campos_subseccion}
    ${tipo_identificador2}=    obtener tipo de identificador2    ${opcion}    ${subseccion}

#    FOR    ${i}    IN RANGE    0    1
    FOR    ${i}    IN RANGE    0    ${tam_subseccion}

        ${valores_excel}=    get from list    ${valores_subseccion}    ${i}
        ${identificador1}=    obtener identificador subentidad    ${opcion}    ${subseccion}    ${valores_excel}
        ${identificador2}=    obtener identificador2 subentidad    ${opcion}    ${subseccion}    ${valores_excel}

        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list

        FOR    ${j}    IN RANGE    0    ${N_CAMPOS}
            ${n}=    sumar    ${j}    1
            ${valor}=    set variable    -

#            log to console    CAMPO ACTUAL: ${campos_subseccion}[${j}]

            @{Lista_ubicacion}=    separarRutaJSON    ${ubicacion_campos_subseccion}[${j}][0]
#            log to console    ${Lista_ubicacion}
            ${N_LISTA}=    get length    ${Lista_ubicacion}

            @{Valores}=    get value from json    ${datos_API}    ${Lista_ubicacion}[0]
#            log to console    Valores del planConceptList: ${Valores}
            ${Valores}=    get from list    ${Valores}    0
            ${N_VALORES}=    get length    ${Valores}
#            log to console    GRUPO DE VALORES: ${Valores}
            ${encontrado}=    set variable    No
            ${encontrado_solo_tipo}=    set variable    No

            FOR    ${k}    IN RANGE    0    ${N_VALORES}
                IF    "${encontrado}" == "No"
                    ${estado}=    run keyword and return status    get from list    ${Valores}    ${k}
                    IF    "${estado}"=="True"
                        ${valor1}=    get from list    ${Valores}    ${k}
                    ELSE
                        ${valor1}=    set variable    ${Valores}
                    END
#                    log to console    VALOR: ${valor1}
                    ${N_VALORES1}=    get length    ${valor1}

                    ${IDENTIFICADOR_JSON}=    get value from json    ${valor1}    ${tipo_identificador}
#                    log to console    IDENTIFICADOR: ${IDENTIFICADOR_JSON}
                    ${tam_ident}=    get length    ${IDENTIFICADOR_JSON}

                    IF    "${tam_ident}" != "0"
                        IF    "${identificador1}" == "${IDENTIFICADOR_JSON}[0]"
                            @{Valores2}=    get value from json    ${valor1}    ${Lista_ubicacion}[1]
    #                        log to console    ${Valores2}
                            ${estado2}=    run keyword and return status    get from list    ${Valores2}    0
                            IF    "${campos_subseccion}[${j}]" == "Identificador del Fichero"
                                IF    "${estado2}"=="True"
                                    ${valor}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor}=    set variable    ${Valores2}
                                END
#                                log to console    ${valor}
                                ${encontrado}=    set variable    Si
                                ${encontrado_solo_tipo}=    set variable    Si

                            ELSE
                                IF    "${estado2}"=="True"
                                    ${valor2}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor2}=    set variable    ${Valores2}
                                END
                                ${N_VALORES2}=    get length    ${valor2}

                                FOR    ${p}    IN RANGE    0    ${N_VALORES2}
                                    IF    "${encontrado}" == "No"
                                        ${JSON_Valores3}=    get from list    ${valor2}    ${p}
#                                           log to console    VALOR DEL JSON: ${JSON_Valores3}
                                        ${IDENTIFICADOR_JSON2}=    get value from json    ${JSON_Valores3}    ${tipo_identificador2}
#                                        log to console    IDENTIFICADOR 2: ${IDENTIFICADOR_JSON}
                                        ${tam_ident2}=    get length    ${IDENTIFICADOR_JSON2}

                                        ${IDENTIFICADOR_JSON2}=    get from list    ${IDENTIFICADOR_JSON2}    0

                                        IF    "${tam_ident2}" != "0"
                                            IF    "${identificador2}" == "${IDENTIFICADOR_JSON2}"
                                                @{Valores3}=    get value from json    ${JSON_Valores3}    ${Lista_ubicacion}[2]
#                                                            log to console    ${Valores3}
                                                ${estado3}=    run keyword and return status    get from list    ${Valores3}    0
                                                IF    "${estado3}"=="True"
                                                    ${valor}=    get from list    ${Valores3}    0
                                                ELSE
                                                    ${valor}=    set variable    ${Valores3}
                                                END
#                                                    log to console    VALOR: ${valor}
                                                ${encontrado}=    set variable    Si
                                                ${encontrado_solo_tipo}=    set variable    Otros
                                            END
                                        END
                                    END
                                END
                            END
                        END
                    END
                END
            END

            ${test}=    set variable    -
#            log to console    VALOR DE SUBENTIDAD: ${valor}

            IF    "${encontrado}" == "Si"
                @{lista_valor_excel}=    get from list    ${valores_subseccion}    ${i}
                ${valor_excel}=    get from list    ${lista_valor_excel}    ${n}
                ${valor_excel}=    modificar si es fecha    ${valor_excel}
#                log to console    VALOR DEL EXCEL: ${valor_excel}
                ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valores_subseccion}[${i}][${n}]

                IF    "${esta_vacio}" != "False"
                    IF    """${valor}""" != """${valor_excel}"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    ${valor}
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                ELSE
                    IF    """${valor_excel}""" != """-"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    -
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                END
            END
        END

        ${N_LISTA}=    get length    ${lista_campos_diferentes}
        IF    "${N_LISTA}" != "0"
            ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][2] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
            realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

        ELSE
            IF    "${encontrado_solo_tipo}" == "Otros"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][2] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            ELSE
                ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][2]
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            END
        END

    END

Validar configuracion - asignacion acuerdo
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}        ${valores_plan}

    log to console    VALIDANDO ${subseccion}
    ${N_CAMPOS}=    get length    ${campos_subseccion}
    ${tipo_identificador2}=    obtener tipo de identificador2    ${opcion}    ${subseccion}

#    FOR    ${i}    IN RANGE    0    1
    FOR    ${i}    IN RANGE    0    ${tam_subseccion}

        ${valores_excel}=    get from list    ${valores_subseccion}    ${i}
        ${identificador1}=    obtener identificador subentidad    ${opcion}    ${subseccion}    ${valores_excel}
#        ${tipo_identificador}=    modificar tipo de identificador - estructura    ${valores_plan}    ${identificador1}
        ${identificador1}=    MODIFICAR ID ESTRUCTURA    ${valores_plan}    ${identificador1}
        ${identificador2}=    obtener identificador2 subentidad    ${opcion}    ${subseccion}    ${valores_excel}

        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list

        FOR    ${j}    IN RANGE    0    ${N_CAMPOS}
            ${n}=    sumar    ${j}    1
            ${valor}=    set variable    -

#            log to console    CAMPO ACTUAL: ${campos_subseccion}[${j}]

            @{Lista_ubicacion}=    separarRutaJSON    ${ubicacion_campos_subseccion}[${j}][0]
#            log to console    ${Lista_ubicacion}
            ${N_LISTA}=    get length    ${Lista_ubicacion}

            @{Valores}=    get value from json    ${datos_API}    ${Lista_ubicacion}[0]
#            log to console    Valores del planConceptList: ${Valores}
            ${Valores}=    get from list    ${Valores}    0
            ${N_VALORES}=    get length    ${Valores}
#            log to console    GRUPO DE VALORES: ${Valores}
            ${encontrado}=    set variable    No
            ${encontrado_solo_tipo}=    set variable    No

            FOR    ${k}    IN RANGE    0    ${N_VALORES}
                IF    "${encontrado}" == "No"
                    ${estado}=    run keyword and return status    get from list    ${Valores}    ${k}
                    IF    "${estado}"=="True"
                        ${valor1}=    get from list    ${Valores}    ${k}
                    ELSE
                        ${valor1}=    set variable    ${Valores}
                    END
#                    log to console    VALOR: ${valor1}
                    ${N_VALORES1}=    get length    ${valor1}

                    ${IDENTIFICADOR_JSON}=    get value from json    ${valor1}    ${tipo_identificador}
#                    log to console    IDENTIFICADOR: ${IDENTIFICADOR_JSON}
                    ${tam_ident}=    get length    ${IDENTIFICADOR_JSON}

                    IF    "${tam_ident}" != "0"
                        IF    "${identificador1}" == "${IDENTIFICADOR_JSON}[0]"
                            @{Valores2}=    get value from json    ${valor1}    ${Lista_ubicacion}[1]
    #                        log to console    ${Valores2}
                            ${estado2}=    run keyword and return status    get from list    ${Valores2}    0
                            IF    "${campos_subseccion}[${j}]" == "Estructura"
                                IF    "${estado2}"=="True"
                                    ${valor}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor}=    set variable    ${Valores2}
                                END
        #                        log to console    ${valor}
                                ${encontrado}=    set variable    Si
                                ${encontrado_solo_tipo}=    set variable    Si

                            ELSE
                                IF    "${estado2}"=="True"
                                    ${valor2}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor2}=    set variable    ${Valores2}
                                END
                                ${N_VALORES2}=    get length    ${valor2}

                                FOR    ${p}    IN RANGE    0    ${N_VALORES2}
                                    IF    "${encontrado}" == "No"
                                        ${JSON_Valores3}=    get from list    ${valor2}    ${p}
#                                           log to console    VALOR DEL JSON: ${JSON_Valores3}

                                        ${IDENTIFICADOR_JSON2}=    get value from json    ${JSON_Valores3}    ${tipo_identificador2}
#                                           log to console    IDENTIFICADOR: ${IDENTIFICADOR_JSON}
                                        ${tam_ident2}=    get length    ${IDENTIFICADOR_JSON2}

                                        ${IDENTIFICADOR_JSON2}=    get from list    ${IDENTIFICADOR_JSON2}    0

                                        IF    "${tam_ident2}" != "0"
                                            IF    "${identificador2}" == "${IDENTIFICADOR_JSON2}"
                                                IF    "${campos_subseccion}[${j}]" != "Valor"
                                                    @{Valores3}=    get value from json    ${JSON_Valores3}    ${Lista_ubicacion}[2]
    #                                                            log to console    ${Valores3}
                                                ELSE
                                                    ${ubicacion}=    modificar identificador - tipo de criterio    ${JSON_Valores3}
                                                    @{Valores3}=    get value from json    ${JSON_Valores3}    ${ubicacion}
                                                END

                                                ${estado3}=    run keyword and return status    get from list    ${Valores3}    0
                                                IF    "${estado3}"=="True"
                                                    ${valor}=    get from list    ${Valores3}    0
                                                ELSE
                                                    ${valor}=    set variable    ${Valores3}
                                                END
#                                                    log to console    VALOR: ${valor}
                                                ${encontrado}=    set variable    Si
                                                ${encontrado_solo_tipo}=    set variable    Otros
                                            END
                                        END
                                    END
                                END
                            END
                        END
                    END
                END
            END

            ${test}=    set variable    -
#            log to console    VALOR DE SUBENTIDAD: ${valor}

            IF    "${encontrado}" == "Si"
                @{lista_valor_excel}=    get from list    ${valores_subseccion}    ${i}
                ${valor_excel}=    get from list    ${lista_valor_excel}    ${n}
                ${valor_excel}=    modificar si es fecha    ${valor_excel}
                IF    "${campos_subseccion}[${j}]" == "Estructura"
                    ${valor_excel}=    MODIFICAR ID ESTRUCTURA    ${valores_plan}    ${valor_excel}
                END
#                log to console    VALOR DEL EXCEL: ${valor_excel}
                ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valores_subseccion}[${i}][${n}]

                IF    "${esta_vacio}" != "False"
                    IF    """${valor}""" != """${valor_excel}"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    ${valor}
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                ELSE
                    IF    """${valor_excel}""" != """-"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    -
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                END
            END
        END

        ${N_LISTA}=    get length    ${lista_campos_diferentes}
        IF    "${N_LISTA}" != "0"
            ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][2] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
            realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

        ELSE
            IF    "${encontrado_solo_tipo}" == "Otros"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][2] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            ELSE
                ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][2]
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            END
        END

    END

Validar configuracion - oferta y rol acuerdo
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}        ${valores_plan}

    log to console    VALIDANDO ${subseccion}
    ${N_CAMPOS}=    get length    ${campos_subseccion}
    ${tipo_identificador2}=    obtener tipo de identificador2    ${opcion}    ${subseccion}

#    FOR    ${i}    IN RANGE    0    1
    FOR    ${i}    IN RANGE    0    ${tam_subseccion}

        ${valores_excel}=    get from list    ${valores_subseccion}    ${i}
        ${identificador1}=    obtener identificador subentidad    ${opcion}    ${subseccion}    ${valores_excel}
#        ${tipo_identificador}=    modificar tipo de identificador - estructura    ${valores_plan}    ${identificador1}
#        ${identificador1}=    MODIFICAR ID ESTRUCTURA    ${valores_plan}    ${identificador1}
        ${identificador2}=    obtener identificador2 subentidad    ${opcion}    ${subseccion}    ${valores_excel}

        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list

        FOR    ${j}    IN RANGE    0    ${N_CAMPOS}
            ${n}=    sumar    ${j}    1
            ${valor}=    set variable    -

#            log to console    CAMPO ACTUAL: ${campos_subseccion}[${j}]

            @{Lista_ubicacion}=    separarRutaJSON    ${ubicacion_campos_subseccion}[${j}][0]
#            log to console    ${Lista_ubicacion}
            ${N_LISTA}=    get length    ${Lista_ubicacion}

            @{Valores}=    get value from json    ${valores_plan}    ${Lista_ubicacion}[0]
#            log to console    Valores del planConceptList: ${Valores}
            ${Valores}=    get from list    ${Valores}    0
            ${N_VALORES}=    get length    ${Valores}
#            log to console    GRUPO DE VALORES: ${Valores}
            ${encontrado}=    set variable    No
            ${encontrado_solo_tipo}=    set variable    No

            FOR    ${k}    IN RANGE    0    ${N_VALORES}
                IF    "${encontrado}" == "No"
                    ${estado}=    run keyword and return status    get from list    ${Valores}    ${k}
                    IF    "${estado}"=="True"
                        ${valor1}=    get from list    ${Valores}    ${k}
                    ELSE
                        ${valor1}=    set variable    ${Valores}
                    END
#                    log to console    VALOR: ${valor1}
                    ${N_VALORES1}=    get length    ${valor1}

                    ${IDENTIFICADOR_JSON}=    get value from json    ${valor1}    ${tipo_identificador}
#                    log to console    IDENTIFICADOR: ${IDENTIFICADOR_JSON}
                    ${tam_ident}=    get length    ${IDENTIFICADOR_JSON}

                    IF    "${tam_ident}" != "0"
                        IF    "${identificador1}" == "${IDENTIFICADOR_JSON}[0]"
                            @{Valores2}=    get value from json    ${valor1}    ${Lista_ubicacion}[1]
    #                        log to console    ${Valores2}
                            ${estado2}=    run keyword and return status    get from list    ${Valores2}    0
                            IF    "${campos_subseccion}[${j}]" == "Estructura"
                                IF    "${estado2}"=="True"
                                    ${valor}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor}=    set variable    ${Valores2}
                                END
        #                        log to console    ${valor}
                                ${encontrado}=    set variable    Si
                                ${encontrado_solo_tipo}=    set variable    Si

                            ELSE
                                IF    "${estado2}"=="True"
                                    ${valor2}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor2}=    set variable    ${Valores2}
                                END
                                ${N_VALORES2}=    get length    ${valor2}

                                FOR    ${p}    IN RANGE    0    ${N_VALORES2}
                                    IF    "${encontrado}" == "No"
                                        ${JSON_Valores3}=    get from list    ${valor2}    ${p}
#                                           log to console    VALOR DEL JSON: ${JSON_Valores3}
                                        ${IDENTIFICADOR_JSON2}=    get value from json    ${JSON_Valores3}    ${tipo_identificador2}
#                                           log to console    IDENTIFICADOR: ${IDENTIFICADOR_JSON}
                                        ${tam_ident2}=    get length    ${IDENTIFICADOR_JSON2}

                                        ${IDENTIFICADOR_JSON2}=    get from list    ${IDENTIFICADOR_JSON2}    0

                                        IF    "${tam_ident2}" != "0"
                                            IF    "${identificador2}" == "${IDENTIFICADOR_JSON2}"
                                                @{Valores3}=    get value from json    ${JSON_Valores3}    ${Lista_ubicacion}[2]
#                                                            log to console    ${Valores3}
                                                ${estado3}=    run keyword and return status    get from list    ${Valores3}    0
                                                IF    "${estado3}"=="True"
                                                    ${valor}=    get from list    ${Valores3}    0
                                                ELSE
                                                    ${valor}=    set variable    ${Valores3}
                                                END
#                                                    log to console    VALOR: ${valor}
                                                ${encontrado}=    set variable    Si
                                                ${encontrado_solo_tipo}=    set variable    Otros
                                            END
                                        END
                                    END
                                END
                            END
                        END
                    END
                END
            END

            ${test}=    set variable    -
#            log to console    VALOR DE SUBENTIDAD: ${valor}

            IF    "${encontrado}" == "Si"
                @{lista_valor_excel}=    get from list    ${valores_subseccion}    ${i}
                ${valor_excel}=    get from list    ${lista_valor_excel}    ${n}
                ${valor_excel}=    modificar si es fecha    ${valor_excel}
#                log to console    VALOR DEL EXCEL: ${valor_excel}
                ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valores_subseccion}[${i}][${n}]

                IF    "${esta_vacio}" != "False"
                    IF    """${valor}""" != """${valor_excel}"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    ${valor}
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                ELSE
                    IF    """${valor_excel}""" != """-"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    -
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                END
            END
        END

        ${N_LISTA}=    get length    ${lista_campos_diferentes}
        IF    "${N_LISTA}" != "0"
            ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][2] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
            realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

        ELSE
            IF    "${encontrado_solo_tipo}" == "Otros"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][2] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            ELSE
                ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][2]
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            END
        END

    END

Validar configuracion - rango excepciones
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}

    log to console    VALIDANDO RANGO EXCEPCIONES
    ${N_CAMPOS}=    get length    ${campos_subseccion}
    ${tipo_identificador2}=    obtener tipo de identificador2    ${opcion}    ${subseccion}


    FOR    ${i}    IN RANGE    0    ${tam_subseccion}

        ${valores_excel}=    get from list    ${valores_subseccion}    ${i}
        ${identificador1}=    obtener identificador subentidad    ${opcion}    ${subseccion}    ${valores_excel}
        ${identificador1}=    MODIFICAR TIPO EXCEPCION    ${identificador1}
        ${identificador2}=    obtener identificador2 subentidad    ${opcion}    ${subseccion}    ${valores_excel}

        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list

        FOR    ${j}    IN RANGE    0    ${N_CAMPOS}
            ${n}=    sumar    ${j}    1
            ${valor}=    set variable    -

#            log to console    CAMPO ACTUAL: ${campos_subseccion}[${j}]

            @{Lista_ubicacion}=    separarRutaJSON    ${ubicacion_campos_subseccion}[${j}][0]
#            log to console    ${Lista_ubicacion}
            ${N_LISTA}=    get length    ${Lista_ubicacion}

            @{Valores}=    get value from json    ${datos_API}    ${Lista_ubicacion}[0]
            ${Valores}=    get from list    ${Valores}    0
            ${N_VALORES}=    get length    ${Valores}
#            log to console    GRUPO DE VALORES: ${Valores}
            ${encontrado}=    set variable    No
            ${encontrado_solo_tipo}=    set variable    No

            FOR    ${k}    IN RANGE    0    ${N_VALORES}
                IF    "${encontrado}" == "No"
                    ${estado}=    run keyword and return status    get from list    ${Valores}    ${k}
                    IF    "${estado}"=="True"
                        ${valor1}=    get from list    ${Valores}    ${k}
                    ELSE
                        ${valor1}=    set variable    ${Valores}
                    END
#                    log to console    VALOR: ${valor1}
                    ${N_VALORES1}=    get length    ${valor1}

                    ${IDENTIFICADOR_JSON}=    get value from json    ${valor1}    ${tipo_identificador}
#                    log to console    IDENTIFICADOR: ${IDENTIFICADOR_JSON}
                    ${tam_ident}=    get length    ${IDENTIFICADOR_JSON}

                    IF    "${tam_ident}" != "0"
                        IF    "${identificador1}" == "${IDENTIFICADOR_JSON}[0]"
                            @{Valores2}=    get value from json    ${valor1}    ${Lista_ubicacion}[1]
    #                        log to console    ${Valores2}
                            ${estado2}=    run keyword and return status    get from list    ${Valores2}    0
                            IF    "${campos_subseccion}[${j}]" == "Tipo"
                                IF    "${estado2}"=="True"
                                    ${valor}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor}=    set variable    ${Valores2}
                                END
        #                        log to console    ${valor}
                                ${encontrado}=    set variable    Si
                                ${encontrado_solo_tipo}=    set variable    Si

                            ELSE
                                IF    "${estado2}"=="True"
                                    ${valor2}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor2}=    set variable    ${Valores2}
                                END
                                ${N_VALORES2}=    get length    ${valor2}

                                FOR    ${p}    IN RANGE    0    ${N_VALORES2}
                                    IF    "${encontrado}" == "No"
                                        ${JSON_Valores3}=    get from list    ${valor2}    ${p}
#                                           log to console    VALOR DEL JSON: ${JSON_Valores3}
                                        ${IDENTIFICADOR_JSON2}=    get value from json    ${JSON_Valores3}    ${tipo_identificador2}
#                                           log to console    IDENTIFICADOR: ${IDENTIFICADOR_JSON}
                                        ${tam_ident2}=    get length    ${IDENTIFICADOR_JSON2}

                                        ${IDENTIFICADOR_JSON2}=    get from list    ${IDENTIFICADOR_JSON2}    0

                                        IF    "${tam_ident2}" != "0"
                                            IF    "${identificador2}" == "${IDENTIFICADOR_JSON2}"
                                                @{Valores3}=    get value from json    ${JSON_Valores3}    ${Lista_ubicacion}[2]
#                                                            log to console    ${Valores3}
                                                ${estado3}=    run keyword and return status    get from list    ${Valores3}    0
                                                IF    "${estado3}"=="True"
                                                    ${valor}=    get from list    ${Valores3}    0
                                                ELSE
                                                    ${valor}=    set variable    ${Valores3}
                                                END
#                                                    log to console    VALOR: ${valor}
                                                ${encontrado}=    set variable    Si
                                                ${encontrado_solo_tipo}=    set variable    Otros
                                            END
                                        END
                                    END
                                END
                            END
                        END
                    END
                END
            END

            ${test}=    set variable    -
#            log to console    VALOR DE SUBENTIDAD: ${valor}

            IF    "${encontrado_solo_tipo}" == "Otros"
                @{lista_valor_excel}=    get from list    ${valores_subseccion}    ${i}
                ${valor_excel}=    get from list    ${lista_valor_excel}    ${n}
                ${valor_excel}=    modificar si es fecha    ${valor_excel}
#                log to console    VALOR DEL EXCEL: ${valor_excel}
                ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valores_subseccion}[${i}][${n}]

                IF    "${esta_vacio}" != "False"
                    IF    """${valor}""" != """${valor_excel}"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    ${valor}
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                ELSE
                    IF    """${valor_excel}""" != """-"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    -
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                END
            END
        END

        ${N_LISTA}=    get length    ${lista_campos_diferentes}
        IF    "${N_LISTA}" != "0"
            ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][2] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
            realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

        ELSE
            IF    "${encontrado_solo_tipo}" == "Otros"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][2] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            ELSE
                ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][2]
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            END
        END

    END

Validar configuracion - dist puntos
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}

    log to console    VALIDANDO DISTRIBUCION PUNTOS
    ${N_CAMPOS}=    get length    ${campos_subseccion}

    FOR    ${i}    IN RANGE    0    ${tam_subseccion}

        ${valores_excel}=    get from list    ${valores_subseccion}    ${i}
        ${identificador}=    obtener identificador subentidad    ${opcion}    ${subseccion}    ${valores_excel}
        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list

        FOR    ${j}    IN RANGE    0    ${N_CAMPOS}
            ${n}=    sumar    ${j}    1
            ${valor}=    set variable    -

#            log to console    CAMPO ACTUAL: ${campos_subseccion}[${j}]

            @{Lista_ubicacion}=    separarRutaJSON    ${ubicacion_campos_subseccion}[${j}][0]
#            log to console    ${Lista_ubicacion}
            ${N_LISTA}=    get length    ${Lista_ubicacion}

            @{Valores}=    get value from json    ${datos_API}    ${Lista_ubicacion}[0]
            ${Valores}=    get from list    ${Valores}    0
            ${N_VALORES}=    get length    ${Valores}
#            log to console    GRUPO DE VALORES: ${Valores}
            ${encontrado}=    set variable    No

            FOR    ${k}    IN RANGE    0    ${N_VALORES}
                IF    "${encontrado}" == "No"
                    ${estado}=    run keyword and return status    get from list    ${Valores}    ${k}
                    IF    "${estado}"=="True"
                        ${valor1}=    get from list    ${Valores}    ${k}
                    ELSE
                        ${valor1}=    set variable    ${Valores}
                    END

#                    log to console    VALOR: ${valor1}
                    ${N_VALORES1}=    get length    ${valor1}

                    ${IDENTIFICADOR_JSON}=    obtener identificador - matriz dist puntos    ${valor1}    ${valores_excel}[1]
#                    log to console    IDENTIFICADOR: ${IDENTIFICADOR_JSON}

                    IF    """${IDENTIFICADOR_JSON}""" != """-"""
                        ${encontrado}=    set variable    Si
                        IF    "${campos_subseccion}[${j}]" == "Elementos"
                            ${valor}=    get from list    ${valores_excel}    1
                        ELSE IF    "${campos_subseccion}[${j}]" == "Puntos"
                            @{valor2}=    get value from json    ${valor1}    points
#                            log to console    POINTS-1: ${valor2}
                            ${estado}=    run keyword and return status    get from list    ${valor2}    0
                            IF    "${estado}"=="True"
                                ${valor}=    get from list    ${valor2}    0
                            ELSE
                                ${valor}=    set variable    ${valor2}
                            END
#                            log to console    POINTS-2: ${valor}
                        END
                    END
                END
            END

            ${test}=    set variable    -
#            log to console    VALOR DE SUBENTIDAD: ${valor}

            IF    "${encontrado}" == "Si"
                @{lista_valor_excel}=    get from list    ${valores_subseccion}    ${i}
                ${valor_excel}=    get from list    ${lista_valor_excel}    ${n}
                ${valor_excel}=    modificar si es fecha    ${valor_excel}
                ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valores_subseccion}[${i}][${n}]

                IF    "${esta_vacio}" != "False"
                    IF    """${valor}""" != """${valor_excel}"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    ${valor}
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                ELSE
                    IF    """${valor_excel}""" != """-"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    -
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                END
            END
        END

        ${N_LISTA}=    get length    ${lista_campos_diferentes}
        IF    "${N_LISTA}" != "0"
            ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
            realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

        ELSE
            IF    "${encontrado}" == "Si"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            ELSE
                ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][1]
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            END
        END

    END

Validar configuracion - condicion intervalo
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}    ${valores_condiciones}

    ${N_CAMPOS}=    get length    ${campos_subseccion}
#    LOG TO CONSOLE    VALIDANDO CONDICIONES INTERVALOS

    FOR    ${i}    IN RANGE    0    ${tam_subseccion}
        ${valores_excel}=    get from list    ${valores_subseccion}    ${i}
        ${identificador}=    obtener identificador subentidad    ${opcion}    ${subseccion}    ${valores_excel}
        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list

        ${json}=    set variable    -
        ${n_valores_condiciones}=    get length    ${valores_condiciones}
        FOR    ${j}    IN RANGE    0    ${n_valores_condiciones}
            ${json_actual}=    get from list    ${valores_condiciones}    ${j}
#            log to console    JSON ACTUAL: ${json_actual}

            @{iden_json}=    get value from json    ${json_actual}    nick
            ${identificador_json}=    get from list    ${iden_json}    0
#            log to console    identificador json: ${identificador_json}
#            log to console    identificador excel: ${identificador}

            IF    "${identificador_json}"=="${identificador}"
                ${json}=    set variable    ${json_actual}
                BREAK
            END
        END

#        log to console    ${json}

        IF    """${json}""" != """-"""
            ${encontrado}=    set variable    Si
            FOR    ${j}    IN RANGE    0    ${N_CAMPOS}
                ${n}=    sumar    ${j}    1
                ${valor_excel}=    get from list    ${valores_excel}    ${n}

                @{Lista_ubicacion}=    separarRutaJSON    ${ubicacion_campos_subseccion}[${j}][0]
                @{Valor}=    get value from json    ${json}    ${Lista_ubicacion}[0]

                ${estado}=    run keyword and return status    get from list    ${Valor}    0
                IF    "${estado}"=="True"
                    ${valor}=    get from list    ${Valor}    0
                ELSE
                    ${valor}=    set variable    ${Valor}
                END

                ${valor_excel}=    modificar si es fecha    ${valor_excel}
                ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valor_excel}

    #            log to console    ${esta_vacio}

                IF    "${esta_vacio}" != "False"
                    IF    """${valor}""" != """${valor_excel}"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    ${valor}
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                ELSE
                    IF    """${valor_excel}""" != """-"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    -
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                END
            END
        ELSE
            ${encontrado}=    set variable    No
        END

        ${N_LISTA}=    get length    ${lista_campos_diferentes}
        IF    "${N_LISTA}" != "0"
            ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
            realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}
        ELSE
            IF    "${encontrado}" == "Si"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}
            ELSE
                ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][1]
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}
            END
        END
    END


Validar configuracion - rango intervalo
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}    ${valores_condiciones}

    ${N_CAMPOS}=    get length    ${campos_subseccion}
#    LOG TO CONSOLE    VALIDANDO RANGOS INTERVALOS

    FOR    ${i}    IN RANGE    0    ${tam_subseccion}
        ${valores_excel}=    get from list    ${valores_subseccion}    ${i}
        ${identificador}=    obtener identificador subentidad    ${opcion}    ${subseccion}    ${valores_excel}
        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list

        ${json}=    set variable    -
        ${n_valores_condiciones}=    get length    ${valores_condiciones}

        FOR    ${j}    IN RANGE    0    ${n_valores_condiciones}
            ${json_actual}=    get from list    ${valores_condiciones}    ${j}
#            log to console    ${json_actual}
            @{iden_json}=    get value from json    ${json_actual}    nick
            ${identificador_json}=    get from list    ${iden_json}    0
            IF    "${identificador_json}"=="${valores_excel}[1]"
                @{id_condicion}=    get value from json    ${json_actual}    id
                ${id_condicion}=    get from list    ${id_condicion}    0
#                log to console    ${id_condicion}
                BREAK
            END
        END
#        log to console    ${id_condicion}

        ${json}=    obtener data - rango intervalo    ${id_condicion}

#        log to console    ${json}

        IF    """${json}""" != """-"""
            ${n_json}=    get length    ${json}
            ${encontrado}=    set variable    No

            FOR    ${k}    IN RANGE    0    ${n_json}
                IF    "${encontrado}"=="No"
                    ${json_actual}=    get from list  ${json}  ${k}

                    @{ident}=    get value from json    ${json_actual}    ${tipo_identificador}
                    ${ident_json}=    get from list    ${ident}    0

                    IF    "${ident_json}" == "${identificador}"
                        ${encontrado}=    set variable    Si
                        FOR    ${j}    IN RANGE    0    ${N_CAMPOS}
                            ${n}=    sumar    ${j}    1
                            ${valor_excel}=    get from list    ${valores_excel}    ${n}

                            @{Lista_ubicacion}=    separarRutaJSON    ${ubicacion_campos_subseccion}[${j}][0]
                            @{Valor}=    get value from json    ${json_actual}    ${Lista_ubicacion}[0]

                            ${estado}=    run keyword and return status    get from list    ${Valor}    0
                            IF    "${estado}"=="True"
                                ${valor}=    get from list    ${Valor}    0
                            ELSE
                                ${valor}=    set variable    ${Valor}
                            END

                            ${valor_excel}=    modificar si es fecha    ${valor_excel}
                            ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valor_excel}

                #            log to console    ${esta_vacio}

                            IF    "${esta_vacio}" != "False"
                                IF    """${valor}""" != """${valor_excel}"""
                                    append to list    ${lista_valores_excel}    ${valor_excel}
                                    append to list    ${lista_valores_api}    ${valor}
                                    append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                                END
                            ELSE
                                IF    """${valor_excel}""" != """-"""
                                    append to list    ${lista_valores_excel}    ${valor_excel}
                                    append to list    ${lista_valores_api}    -
                                    append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                                END
                            END
                        END
                    END
                END
            END
        ELSE
            ${encontrado}=    set variable    No
        END

        ${N_LISTA}=    get length    ${lista_campos_diferentes}
        IF    "${N_LISTA}" != "0"
            ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
            realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}
        ELSE
            IF    "${encontrado}" == "Si"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}
            ELSE
                ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][1]
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}
            END
        END
    END

Validar configuracion - dia de semana
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}

    ${N_CAMPOS}=    get length    ${campos_subseccion}


#    log to console    ${tam_subseccion}

    FOR    ${i}    IN RANGE    0    ${tam_subseccion}
        ${identificador}=    obtener identificador subentidad    ${opcion}    ${subseccion}    ${valores_subseccion}[${i}]
        ${identificador}=    cambiar dia    ${identificador}
        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list

        log to console    ${identificador}
        FOR    ${j}    IN RANGE    0    ${N_CAMPOS}
            ${n}=    sumar    ${j}    1
            ${valor}=    set variable    -

            @{Lista_ubicacion}=    separarRutaJSON    ${ubicacion_campos_subseccion}[${j}][0]
#            log to console    ${Lista_ubicacion}
            ${N_LISTA}=    get length    ${Lista_ubicacion}

            @{Valores}=    get value from json    ${datos_API}    ${Lista_ubicacion}[0]
            ${N_VALORES}=    get length    ${Valores}
#            log to console    ${N_VALORES}
            ${encontrado}=    set variable    No


            FOR    ${k}    IN RANGE    0    ${N_VALORES}
                IF    "${encontrado}" == "No"
                    ${estado}=    run keyword and return status    get from list    ${Valores}    ${k}
                    IF    "${estado}"=="True"
                        ${valor1}=    get from list    ${Valores}    ${k}
                    ELSE
                        ${valor1}=    set variable    ${Valores}
                    END
#                    log to console    VALOR: ${valor1}
                    ${N_VALORES1}=    get length    ${valor1}

                    FOR    ${m}    IN RANGE    0    ${N_VALORES1}
                        ${JSON_Valores2}=    get from list    ${valor1}    ${m}
#                        log to console    VALOR DEL JSON: ${JSON_Valores2}
                        ${IDENTIFICADOR_JSON}=    get value from json    ${JSON_Valores2}    ${tipo_identificador}
#                        log to console    IDENTIFICADOR: ${IDENTIFICADOR_JSON}
                        ${tam_ident}=    get length    ${IDENTIFICADOR_JSON}
#                        log to console    ${tam_ident}
                        IF    "${tam_ident}" != "0"
                            IF    "${identificador}" == "${IDENTIFICADOR_JSON}[0]"
                                @{Valores2}=    get value from json    ${JSON_Valores2}    ${Lista_ubicacion}[1]
#                                log to console    ${Valores2}
                                ${estado}=    run keyword and return status    get from list    ${Valores2}    0
                                IF    "${estado}"=="True"
                                    ${valor}=    get from list    ${Valores2}    0
                                ELSE
                                    ${valor}=    set variable    ${Valores2}
                                END
#                                log to console    VALOR: ${valor}
                                ${encontrado}=    set variable    Si
                            END
                        END
                    END
                END
            END

#            ${test}=    set variable    -
#            log to console    VALOR DE SUBENTIDAD: ${valor}

            IF    "${encontrado}" == "Si"
                @{lista_valor_excel}=    get from list    ${valores_subseccion}    ${i}
                ${valor_excel}=    get from list    ${lista_valor_excel}    ${n}
                IF    ("${campos_subseccion}[${j}]"=="Desde") or ("${campos_subseccion}[${j}]"=="Hasta")
                    ${a}=    sumar    ${n}    1
                    ${valor_excel}=    change hour    ${valor_excel}    ${lista_valor_excel}[${a}]
                    ${valor}=    change hour API    ${valor}
                ELSE IF    "${campos_subseccion}[${j}]"=="Dia"
                    ${valor_excel}=    cambiar dia    ${valor_excel}
                END
                ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valores_subseccion}[${i}][${n}]

    #            log to console    ${esta_vacio}

                IF    "${esta_vacio}" != "False"
                    IF    """${valor}""" != """${valor_excel}"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    ${valor}
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                ELSE
                    IF    """${valor_excel}""" != """-"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    -
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                END
            END
        END

        ${N_LISTA}=    get length    ${lista_campos_diferentes}
        IF    "${N_LISTA}" != "0"
            ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
            realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

#            log to console    Campos distintos: ${lista_campos_diferentes}
#            log to console    Valores segun API: ${lista_valores_api}
#            log to console    Valores segun excel: ${lista_valores_excel}

        ELSE
            IF    "${encontrado}" == "Si"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

#                log to console    No hay campos distintos

            ELSE
                ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][1]
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

#                log to console    No se encontro subentidad ${valores_subseccion}[${i}][1]

            END
        END

    END

Validar configuracion - excepciones
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}    ${valores_excepciones}

    ${N_CAMPOS}=    get length    ${campos_subseccion}

    FOR    ${i}    IN RANGE    0    ${tam_subseccion}
        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list

        ${JSON}=    obtener json - excepciones    ${valores_excepciones}    ${valores_subseccion}[${i}]
#        log to console    JSON PARA ${valores_subseccion}[${i}][1]: ${JSON}
#        log to console    DATOS EXCEL PARA ${valores_subseccion}[${i}][1]: ${valores_subseccion}[${i}]

        IF    """${JSON}""" == """-"""
            ${encontrado}=    set variable    No
        ELSE
            ${encontrado}=    set variable    Si

            FOR    ${j}    IN RANGE    0    ${N_CAMPOS}
                ${n}=    sumar    ${j}    1
                ${valor}=    set variable    -

                @{Lista_ubicacion}=    separarRutaJSON    ${ubicacion_campos_subseccion}[${j}][0]
#                log to console    ${Lista_ubicacion}
                ${N_LISTA}=    get length    ${Lista_ubicacion}

                @{Valores}=    get value from json    ${JSON}    ${Lista_ubicacion}[0]
#                LOG TO CONSOLE    ${Valores}
                ${n_valor}=    get length    ${Valores}
                IF    "${n_valor}" != "0"
                    ${valor}=    get from list    ${Valores}    0
                ELSE
                    ${valor}=    set variable    -
                END
#                log to console    VALOR DE SUBENTIDAD: ${valor}

                @{lista_valor_excel}=    get from list    ${valores_subseccion}    ${i}
                ${valor_excel}=    get from list    ${lista_valor_excel}    ${n}
                ${valor_excel}=    modificar si es fecha    ${valor_excel}

                IF    ("${campos_subseccion}[${j}]" == "Tipo") or ("${campos_subseccion}[${j}]" == "Frecuencia")
                    ${valor_excel}=    MODIFICAR VALOR EXCEL    ${valor_excel}    ${campos_subseccion}[${j}]
                END
#                log to console    VALOR DE EXCEL: ${valor_excel}

                ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valor_excel}

                IF    "${esta_vacio}" != "False"
                    IF    """${valor}""" != """${valor_excel}"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    ${valor}
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                ELSE
                    IF    """${valor_excel}""" != """-"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    -
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                END

            END
        END
        ${N_LISTA}=    get length    ${lista_campos_diferentes}
        IF    "${N_LISTA}" != "0"
            ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
            realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}
        ELSE
            IF    "${encontrado}" == "Si"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}
            ELSE
                ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][1]
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}
            END
        END

    END

Validar configuracion - catalogos
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}    ${valores_catalogos}

#    log to console    ${valores_catalogos}
    ${valores_catalogos}=    get from list    ${valores_catalogos}    0
#    log to console    ${valores_catalogos}
#    log to console    ${valores_subseccion}

    ${n_valores}=    get length    ${valores_subseccion}

    ${lista_id}=    obtener id - campos catalogos    ${datos_API}    id
    ${lista_campos}=    obtener id - campos catalogos    ${datos_API}    tag
    ${identificador}=    obtener identificador - catalogos     ${lista_campos}    ${campos_subseccion}
#    log to console    CAMPOS: ${campos_subseccion}

    FOR    ${i}    IN RANGE    0    ${n_valores}

        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list
        @{lista_ubicaciones_json}=    create list

        log to console    ITEM SUBENTIDAD A EVALUAR: ${valores_subseccion}[${i}]
        ${valores_excel}=    get from list    ${valores_subseccion}    ${i}
        ${n_campos}=    get length    ${campos_subseccion}
        ${json}=    obtener json - campos catalogos    ${valores_catalogos}    ${lista_id}    ${lista_campos}    ${valores_subseccion}[${i}][1]    ${identificador}

        IF    """${json}""" != """-"""
            FOR    ${j}    IN RANGE    0    ${n_campos}
                ${n}=    sumar    1    ${j}
                ${valor_excel}=    get from list    ${valores_excel}    ${n}
                ${valor}=    obtener valor - campos catalogos    ${json}    ${lista_id}    ${lista_campos}    ${campos_subseccion}[${j}]
#                log to console    CAMPO: ${campos_subseccion}[${j}]
#                log to console    VALOR: ${valor}[0]
                ${valor}=    get from list    ${valor}    0
                ${tipo}=    mostrar tipo    ${valor}

                IF    "${tipo}" == "<class 'list'>" or "${tipo}" == "<class 'dict'>"
                    ${res}=    set variable    Si
                    IF    "${tipo}" == "<class 'dict'>"
                        ${valor}=    get value from json    ${valor}    value
                        ${valor}=    get from list    ${valor}    0
                    END
                ELSE
                    ${res}=    set variable    No
                END

                ${valor_excel}=    modificar si es fecha    ${valor_excel}
                ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valores_subseccion}[${i}][${n}]

    #            log to console    ${esta_vacio}

                IF    "${esta_vacio}" != "False"
                    IF    """${valor}""" != """${valor_excel}"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    ${valor}
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                ELSE
                    IF    """${valor_excel}""" != """-"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    -
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                    END
                END

#                log to console    TIPO: ${tipo}
#                log to console    ES LISTA O DICCIONARIO: ${res}
            END

            ${N_LISTA}=    get length    ${lista_campos_diferentes}
            IF    "${N_LISTA}" != "0"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
                realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

    #            log to console    Campos distintos: ${lista_campos_diferentes}
    #            log to console    Valores segun API: ${lista_valores_api}
    #            log to console    Valores segun excel: ${lista_valores_excel}

            ELSE
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}
            END
        ELSE
            ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][1]
            realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}
#            log to console    No se encontro
        END
    END

Validar configuracion - subentidad
    [Arguments]    ${item}    ${opcion}    ${datos_API}    ${campos_subseccion}    ${valores_subseccion}    ${ubicacion_campos_subseccion}    ${tam_subseccion}    ${tipo_identificador}    ${subseccion}    ${flag_reporte}    ${reporte}    ${ID}

    ${N_CAMPOS}=    get length    ${campos_subseccion}

    log to console    VALIDANDO ${subseccion}

#    log to console    ${tam_subseccion}

    FOR    ${i}    IN RANGE    0    ${tam_subseccion}
        ${identificador}=    obtener identificador subentidad    ${opcion}    ${subseccion}    ${valores_subseccion}[${i}]
        IF    "${opcion}"=="Excepciones" and "${subseccion}"=="Origen de excepción"
            ${identificador}=    MODIFICAR ORIGEN EXCEPCION    ${identificador}
        ELSE IF    "${opcion}"=="Excepciones" and "${subseccion}"=="Tipo de excepciones"
            ${identificador}=    MODIFICAR TIPO EXCEPCION    ${identificador}
        END

        @{lista_campos_diferentes}=    create list
        @{lista_valores_excel}=    create list
        @{lista_valores_api}=    create list
        @{lista_ubicaciones_json}=    create list
        ${encontrado}=    set variable    No

#        log to console    IDENTIFICADOR EXCEL: ${identificador}

        FOR    ${j}    IN RANGE    0    ${N_CAMPOS}
            ${n}=    sumar    ${j}    1
            ${valor}=    set variable    -

            @{Lista_ubicacion}=    separarRutaJSON    ${ubicacion_campos_subseccion}[${j}][0]
            @{ubicacion_JSON}=    create list
#            log to console    ${Lista_ubicacion}
            ${N_LISTA}=    get length    ${Lista_ubicacion}

            @{Valores}=    get value from json    ${datos_API}    ${Lista_ubicacion}[0]
            append to list    ${ubicacion_JSON}    ${Lista_ubicacion}[0]

            ${N_VALORES}=    get length    ${Valores}
#            log to console    ${N_VALORES}
            ${encontrado}=    set variable    No

            IF    "${N_LISTA}"=="1"
                IF    "${encontrado}" == "No"
                    ${estado}=    run keyword and return status    get from list    ${Valores}    ${j}
                    IF    "${estado}"=="True"
                        ${valor}=    get from list    ${Valores}    ${j}
                    ELSE
                        ${valor}=    set variable    ${Valores}
                    END

                    ${encontrado}=    set variable    Si
                END
            ELSE
                FOR    ${k}    IN RANGE    0    ${N_VALORES}
                    IF    "${encontrado}" == "No"
                        ${estado}=    run keyword and return status    get from list    ${Valores}    ${k}
                        IF    "${estado}"=="True"
                            ${valor1}=    get from list    ${Valores}    ${k}
                        ELSE
                            ${valor1}=    set variable    ${Valores}
                        END
#                        log to console    VALOR: ${valor1}
                        ${N_VALORES1}=    get length    ${valor1}

                        FOR    ${m}    IN RANGE    0    ${N_VALORES1}
                            ${JSON_Valores2}=    get from list    ${valor1}    ${m}
#                            log to console    VALOR DEL JSON: ${JSON_Valores2}
                            ${IDENTIFICADOR_JSON}=    get value from json    ${JSON_Valores2}    ${tipo_identificador}
#                            log to console    IDENTIFICADOR: ${IDENTIFICADOR_JSON}
                            ${tam_ident}=    get length    ${IDENTIFICADOR_JSON}
#                            log to console    ${tam_ident}
                            IF    "${tam_ident}" != "0"
                                IF    "${identificador}" == "${IDENTIFICADOR_JSON}[0]"
                                    @{Valores2}=    get value from json    ${JSON_Valores2}    ${Lista_ubicacion}[1]
                                    append to list    ${ubicacion_JSON}    ${m}
                                    append to list    ${ubicacion_JSON}    ${Lista_ubicacion}[1]

            #                        log to console    ${Valores2}
                                    ${estado}=    run keyword and return status    get from list    ${Valores2}    0
                                    IF    "${estado}"=="True"
                                        ${valor}=    get from list    ${Valores2}    0
                                    ELSE
                                        ${valor}=    set variable    ${Valores2}
                                    END
            #                        log to console    ${valor}
                                    ${encontrado}=    set variable    Si
                                END
                            END
                        END
                    END
                END
            END

            ${ubicacion_JSON}=    crearCadenaApartirLista    ${ubicacion_JSON}
#            ${test}=    set variable    -
#            log to console    VALOR DE SUBENTIDAD: ${valor}

            IF    "${encontrado}" == "Si"
                @{lista_valor_excel}=    get from list    ${valores_subseccion}    ${i}
                ${valor_excel}=    get from list    ${lista_valor_excel}    ${n}
                ${valor_excel}=    modificar si es fecha    ${valor_excel}
#                log to console    VALOR EXCEL: ${valor_excel}
                ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${valor_excel}
                ${valor_vacio}=    obtenerTamano    ${valor}
    #            log to console    ${esta_vacio}

                IF    ("${esta_vacio}" != "False") and ("${valor_vacio}" != "0")
                    IF    """${valor}""" != """${valor_excel}"""
                        append to list    ${lista_valores_excel}    ${valor_excel}
                        append to list    ${lista_valores_api}    ${valor}
                        append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                        append to list    ${lista_ubicaciones_json}    ${ubicacion_JSON}
                    END
                ELSE
                    IF    "${flag_tipo_ejecucion}" == "VALIDACION"
                        IF    """${valor_excel}""" != """-"""
                            append to list    ${lista_valores_excel}    ${valor_excel}
                            append to list    ${lista_valores_api}    -
                            append to list    ${lista_campos_diferentes}    ${campos_subseccion}[${j}]
                            append to list    ${lista_ubicaciones_json}    ${ubicacion_JSON}
                        END
                    END
                END
            END
        END

        ${N_LISTA}=    get length    ${lista_campos_diferentes}

        IF    "${flag_tipo_ejecucion}" == "VALIDACION"
            IF    "${N_LISTA}" != "0"
                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
                realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

    #            log to console    Campos distintos: ${lista_campos_diferentes}
    #            log to console    Valores segun API: ${lista_valores_api}
    #            log to console    Valores segun excel: ${lista_valores_excel}

            ELSE
                IF    "${encontrado}" == "Si"
                    ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] y esta correctamente configurado
                    realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

    #                log to console    No hay campos distintos

                ELSE
                    ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][1]
                    realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

    #                log to console    No se encontro subentidad ${valores_subseccion}[${i}][1]

                END
            END
        ELSE IF    "${flag_tipo_ejecucion}" == "ACTUALIZACION"
            IF    "${N_LISTA}" != "0"
                log to console    ACTUALIZANDO ...
                log to console    UBICACIONES A ACTUALIZAR: ${lista_ubicaciones_json}
#                log to console    Valores segun API: ${lista_valores_api}
#                log to console    Valores segun excel: ${lista_valores_excel}
                actualizar entidad    ${opcion}    ${ID}    ${lista_ubicaciones_json}    ${lista_valores_excel}

                ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes} , por lo que se actualizaron sus datos
                realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}

            ELSE
                IF    "${encontrado}" == "Si"
                    ${resultado}=    set variable    Existe subentidad con identificador ${valores_subseccion}[${i}][1] y esta correctamente configurado
                    realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}
                ELSE
                    ${resultado}=    set variable    No se encontro subentidad con identificador ${valores_subseccion}[${i}][1]
                    realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${valores_subseccion}[${i}]    SECUNDARIA    ${opcion}    ${subseccion}
                END
            END
        END
    END

Validar configuracion
    [Arguments]    ${datos_excel}    ${datos_API}    ${campos}    ${ubicacion_campos}    ${data_excel}    ${opcion}    ${TIPO_TABLA}    ${flag_reporte}    ${reporte}    ${valores_catalogos}    ${ID}

    ${N_CAMPOS}=    get length    ${campos}

    @{lista_campos_diferentes}=    create list
    @{lista_valores_excel}=    create list
    @{lista_valores_api}=    create list
    @{lista_ubicaciones_json}=    create list

    ${tam_datos_API}=    get length    ${datos_API}

    IF    ("${tam_datos_API}" != "1") and ("${tam_datos_API}" != "0")
        FOR    ${i}    IN RANGE    0    ${N_CAMPOS}

            ${n}=    sumar    ${i}    1

            @{value}=    get value from json    ${datos_API}    ${ubicacion_campos}[${i}][0]

            ${estado}=    run keyword and return status    get from list    ${value}    0

            IF    "${estado}"=="True"
                ${valor}=    get from list    ${value}    0
            ELSE
                ${valor}=    set variable    ${value}
            END

#            log to console    ${campos}[${i}] EN API: ${valor}

    #        ${vacio}=    Run Keyword And Return Status    Should Not Be Empty    ${valor}
    #        log to console    ${vacio}

            ${esta_vacio}=    Run Keyword And Return Status    Esta vacio    ${valor}    ${datos_excel}[${n}]
            ${valor_excel}=    get from list    ${datos_excel}    ${n}
            ${valor_excel}=    modificar si es fecha    ${valor_excel}
#            log to console    ${campos}[${i}] EN EXCEL: ${valor_excel}
    #        log to console    ${esta_vacio}

            IF    "${esta_vacio}" != "False"

                IF    """${valor}""" != """${valor_excel}"""
                    append to list    ${lista_valores_excel}    ${valor_excel}
                    append to list    ${lista_valores_api}    ${valor}
                    append to list    ${lista_campos_diferentes}    ${campos}[${i}]
                    append to list    ${lista_ubicaciones_json}    ${ubicacion_campos}[${i}][0]
                END
            ELSE
                IF    """${valor_excel}""" != """-"""
                    append to list    ${lista_valores_excel}    ${valor_excel}
                    append to list    ${lista_valores_api}    -
                    append to list    ${lista_campos_diferentes}    ${campos}[${i}]
                    append to list    ${lista_ubicaciones_json}    ${ubicacion_campos}[${i}][0]
                END
            END
        END

        ${N_LISTA}=    get length    ${lista_campos_diferentes}
        IF    "${flag_tipo_ejecucion}" == "VALIDACION"
            IF    "${N_LISTA}" != "0"
                ${resultado}=    set variable    Existe entidad con identificador ${datos_excel}[1] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}
                realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${datos_excel}    ${TIPO_TABLA}    ${opcion}    -
    #            log to console    Campos distintos: ${lista_campos_diferentes}
    #            log to console    Valores segun API: ${lista_valores_api}
    #            log to console    Valores segun excel: ${lista_valores_excel}
            ELSE
                ${resultado}=    set variable    Existe entidad con identificador ${datos_excel}[1] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${datos_excel}    ${TIPO_TABLA}    ${opcion}    -
    #            log to console    No hay campos distintos
            END
        ELSE IF    "${flag_tipo_ejecucion}" == "ACTUALIZACION"
            IF    "${N_LISTA}" != "0"
                log to console    ACTUALIZANDO ...
                log to console    UBICACIONES A ACTUALIZAR: ${lista_ubicaciones_json}
                actualizar entidad    ${opcion}    ${ID}    ${lista_ubicaciones_json}    ${lista_valores_excel}    ${datos_API}

                ${resultado}=    set variable    Existe entidad con identificador ${datos_excel}[1] , pero no esta correctamente configurado en los campos: ${lista_campos_diferentes}, por lo que se actualizaron sus datos
                realizar reporte    ${resultado}    ${lista_valores_excel}    ${lista_valores_api}    ${flag_reporte}    ${reporte}    ${datos_excel}    ${TIPO_TABLA}    ${opcion}    -
            ELSE
                ${resultado}=    set variable    Existe entidad con identificador ${datos_excel}[1] y esta correctamente configurado
                realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${datos_excel}    ${TIPO_TABLA}    ${opcion}    -
            END
        END

    ELSE
        IF    "${flag_tipo_ejecucion}" == "VALIDACION"
            ${resultado}=    set variable    No se encontro entidad con identificador ${datos_excel}[1]
            realizar reporte    ${resultado}    -    -    ${flag_reporte}    ${reporte}    ${datos_excel}    ${TIPO_TABLA}    ${opcion}    -
        ELSE IF    "${flag_tipo_ejecucion}" == "ACTUALIZACION"
            log to console    ACTUALIZANDO ...
            log to console    AQUI IRA MODULO DE CREAR
        END
    END

    ${NUM_SUBSECCIONES}=    GET LENGTH    ${data_excel}[6]
    IF    (${NUM_SUBSECCIONES} != 0) and ("${TIPO_TABLA}" == "PRIMARIA") and (("${tam_datos_API}" != "1") and ("${tam_datos_API}" != "0"))
        Validar subentidad    ${opcion}    ${datos_excel}    ${datos_API}    ${data_excel}    ${flag_reporte}    ${reporte}    ${valores_catalogos}    ${ID}
    END

