*** Settings ***
Library    RequestsLibrary
Library    JSONLibrary
Library    Collections
Library    SeleniumLibrary

Library    ../FuncionesPython/FuncionesVarias.py
Variables    ../../Variables/variables.py

*** Keywords ***
Imprimir en consola
    [Arguments]    ${resultado}    ${val_excel}    ${val_api}
    ${json}=    mostrar json en consola    ${resultado}    ${val_excel}    ${val_api}
    log to console    ${json}

Realizar reporte
    [Arguments]    ${resultado}    ${val_excel}    ${val_api}    ${flag_reporte}    ${reporte}    ${valores}    ${tipo_tabla}    ${opcion}    ${subseccion}

    IF    "${flag_reporte}" == "CONSOLA"
        Imprimir en consola    ${resultado}    ${val_excel}    ${val_api}

    ELSE IF    "${flag_reporte}" == "REPORTE"
        IF    '${tipo_tabla}' == 'PRIMARIA'
            llenarreporte    ${reporte}    ${opcion}    ${resultado}    ${val_excel}    ${val_api}    ${valores}[0]    En Proceso
        ELSE
            llenarReporte Subentidad    ${reporte}    ${opcion}    ${valores}[0]    ${resultado}    ${val_excel}    ${val_api}    ${subseccion}
        END

    ELSE IF    "${flag_reporte}" == "AMBOS"
        Imprimir en consola    ${resultado}    ${val_excel}    ${val_api}
        IF    '${tipo_tabla}' == 'PRIMARIA'
            llenarreporte    ${reporte}    ${opcion}    ${resultado}    ${val_excel}    ${val_api}    ${valores}[0]    En Proceso
        ELSE
            llenarReporte Subentidad    ${reporte}    ${opcion}    ${valores}[0]    ${resultado}    ${val_excel}    ${val_api}    ${subseccion}
        END
    END


Esta vacio
    [Arguments]    ${cadena1}    ${cadena2}

    ${resultado}=    set variable    -



    IF    """${cadena1}""" != """${cadena2}"""
        ${resultado}=    set variable    SI
    ELSE
        ${resultado}=    set variable    NO
    END

    [return]    ${resultado}

Obtener tipo de identificador
    [Arguments]    ${opcion}    ${subseccion}

    ${TIPO}=    set variable    -
    IF    "${opcion}"=="Tipos de catálogo"
        IF    "${subseccion}"=="Atributo"
            ${TIPO}=    set variable    identifier
        END
    ELSE IF    "${opcion}" == "Valores posibles"
        IF    "${subseccion}" == "Elemento"
            ${TIPO}=    set variable    identifier
        END
    ELSE IF    "${opcion}" == "Conceptos"
        IF    "${subseccion}" == "Elemento"
            ${TIPO}=    set variable    sourceValue
        END
    ELSE IF    "${opcion}" == "Equivalencias"
        IF    "${subseccion}" == "Elemento"
            ${TIPO}=    set variable    targetValue
        END
    ELSE IF    "${opcion}" == "Clase Ubigeo"
        IF    "${subseccion}" == "Estructura"
            ${TIPO}=    set variable    order
        END
    ELSE IF    "${opcion}" == "Impuestos"
        IF    "${subseccion}" == "Tasa"
            ${TIPO}=    set variable    rate
        END
    ELSE IF    "${opcion}" == "Gestor Agentes - Organización"
        IF    "${subseccion}" == "Detalle"
            ${TIPO}=    set variable    individualName
        ELSE IF    "${subseccion}" == "Segmentos"
            ${TIPO}=    set variable    segmentationTagBean.tag
        END
    ELSE IF    "${opcion}" == "Repositorios"
        IF    "${subseccion}" == "Conexion insumo"
            ${TIPO}=    set variable    name
        END
    ELSE IF    "${opcion}" == "Plan de comision"
        IF    "${subseccion}" == "Estructuras de comision"
            ${TIPO}=    set variable    commissionStructureVersion.description
        ELSE IF    "${subseccion}" == "Estructuras de bonificacion"
            ${TIPO}=    set variable    bonusPlanVersion.description
        END
    ELSE IF    "${opcion}" == "Catalogos"
        IF    "${subseccion}" == "Elemento"
            ${TIPO}=    set variable    tag
        END
    ELSE IF    "${opcion}" == "Penalidades"
        IF    "${subseccion}" == "Origen de la penalidad"
            ${TIPO}=    set variable    itemClass
        ELSE IF    "${subseccion}" == "Item de Condición"
            ${TIPO}=    set variable    itemClass
        ELSE IF    "${subseccion}" == "Reglas de calculo de penalidad"
            ${TIPO}=    set variable    rule
        ELSE IF    "${subseccion}" == "Rango de condicion"
            ${TIPO}=    set variable    startRange
        END
    ELSE IF    "${opcion}" == "Calendario"
        IF    "${subseccion}" == "Dia de Semana"
            ${TIPO}=    set variable    dayOfWeek
        ELSE IF    "${subseccion}" == "Excepciones"
            ${TIPO}=    set variable    description
        END

    ELSE IF    "${opcion}" == "Intervalo"
        IF    "${subseccion}" == "Condicion"
            ${TIPO}=    set variable    nick
        ELSE IF    "${subseccion}" == "Rango"
            ${TIPO}=    set variable    startRange
        END

    ELSE IF    "${opcion}" == "Matriz de puntos"
        IF    "${subseccion}" == "Elementos de la matriz"
            ${TIPO}=    set variable    description
        ELSE IF    "${subseccion}" == "Distribucion de puntos"
            ${TIPO}=    set variable    startRange
        END
    ELSE IF    "${opcion}" == "Excepciones"
        IF    "${subseccion}" == "Origen de excepción"
            ${TIPO}=    set variable    itemClass
        ELSE IF    "${subseccion}" == "Item de evaluación"
            ${TIPO}=    set variable    itemClass
        ELSE IF    "${subseccion}" == "Tipo de excepciones"
            ${TIPO}=    set variable    type
        ELSE IF    "${subseccion}" == "Tipo de excepciones - Rango"
            ${TIPO}=    set variable    type
        END
    ELSE IF    "${opcion}" == "Acuerdos"
        IF    "${subseccion}" == "Oferta comercial"
            ${TIPO}=    set variable    commissionStructureVersion.description
        ELSE IF    "${subseccion}" == "Roles comisionistas"
            ${TIPO}=    set variable    commissionStructureVersion.description
        ELSE IF    "${subseccion}" == "Asignacion de metas por criterios"
            ${TIPO}=    set variable    concept
        END

    ELSE IF    "${opcion}" == "Insumos"
        IF    "${subseccion}" == "Detalle de fichero - estructura"
            ${TIPO}=    set variable    name
        ELSE IF    "${subseccion}" == "Detalle de fichero - campos"
            ${TIPO}=    set variable    name
        ELSE IF    "${subseccion}" == "Enlace"
            ${TIPO}=    set variable    sourceFileInputName
        END

    ELSE IF    "${opcion}" == "Estructura de Comisión"
        IF    "${subseccion}" == "Oferta Comercial"
            ${TIPO}=    set variable    value
        ELSE IF    "${subseccion}" == "Criterio de verificación"
            ${TIPO}=    set variable    value
        ELSE IF    "${subseccion}" == "Rol al que aplica"
            ${TIPO}=    set variable    partyRoleName
        ELSE IF    "${subseccion}" == "Origen de la comisión"
            ${TIPO}=    set variable    value
        ELSE IF    "${subseccion}" == "Criterios de la meta"
            ${TIPO}=    set variable    value
        ELSE IF    "${subseccion}" == "Item de Condición"
            ${TIPO}=    set variable    value
        ELSE IF    "${subseccion}" == "Cumplimiento"
            ${TIPO}=    set variable    -
        ELSE IF    "${subseccion}" == "Condiciones para el cálculo de meta"
            ${TIPO}=    set variable    -
        ELSE IF    "${subseccion}" == "Rangos"
            ${TIPO}=    set variable    startRange
        ELSE IF    "${subseccion}" == "Selección de distribucion"
            ${TIPO}=    set variable    -
        ELSE IF    "${subseccion}" == "Comision periodica"
            ${TIPO}=    set variable    period
        ELSE IF    "${subseccion}" == "Comision periodica - Oferta comercial"
            ${TIPO}=    set variable    period
        ELSE IF    "${subseccion}" == "Comision periodica - Origen de comision"
            ${TIPO}=    set variable    period
        ELSE IF    "${subseccion}" == "Distribucion"
            ${TIPO}=    set variable    period
        ELSE IF    "${subseccion}" == "Distribucion - Pago Condicionado"
            ${TIPO}=    set variable    period
        ELSE IF    "${subseccion}" == "Distribucion - Clawback"
            ${TIPO}=    set variable    period
        ELSE IF    "${subseccion}" == "Distribucion - Condiciones Clawback"
            ${TIPO}=    set variable    period
        ELSE IF    "${subseccion}" == "Condiciones Alteran Distribución - E"
            ${TIPO}=    set variable    -
        ELSE IF    "${subseccion}" == "Condiciones Alteran Distribución"
            ${TIPO}=    set variable    startRange
        END
    END
    [return]    ${TIPO}

Modificar tipo de identificador - estructura
    [Arguments]    ${json_plan}    ${nombre_estructura}

    ${id}=    set variable    -

    @{data_plan}=    get value from json    ${json_plan}    planVersion.planConceptList
    @{lista_estructuras_plan}=    get from list    ${data_plan}    0
#    log to console    DATOS DEL PLAN: ${lista_estructuras_plan}
    ${n_data_plan}=    get length    ${lista_estructuras_plan}
#    log to console    CANTIDAD DE ESTRUCTURAS DENTRO DEL PLAN: ${n_data_plan}
    FOR    ${i}    IN RANGE    0    ${n_data_plan}
        @{tipo_estructura}=    get value from json    ${lista_estructuras_plan}[${i}]    type
        ${tipo}=    get from list    ${tipo_estructura}    0
#        log to console    TIPO DE ESTRUCTURA: ${tipo}
        IF    "${tipo}"=="C"
            @{nombre_estructura_API}=    get value from json    ${lista_estructuras_plan}[${i}]    commissionStructureVersion.description
            ${nombre}=    get from list    ${nombre_estructura_API}    0
#            log to console    NOMBRE DE ESTRUCTURA: ${nombre}
            IF    "${nombre}" == "${nombre_estructura}"
                @{id_estructura}=    get value from json    ${lista_estructuras_plan}[${i}]    id
                ${id}=    get from list    ${id_estructura}    0
                BREAK
            END
        ELSE
            @{nombre_estructura_API}=    get value from json    ${data_plan}[${i}]    bonusPlanVersion.description
            ${nombre}=    get from list    ${nombre_estructura_API}    0
#            log to console    NOMBRE DE ESTRUCTURA: ${nombre}
            IF    "${nombre}" == "${nombre_estructura}"
                @{id_estructura}=    get value from json    ${data_plan}[${i}]    id
                ${id}=    get from list    ${id_estructura}    0
                BREAK
            END
        END
    END

    log to console    ID DE ESTRUCTURA: ${id}
    [return]    ${id}

Obtener tipo de identificador2
    [Arguments]    ${opcion}    ${subseccion}
    ${TIPO}=    set variable    -

    IF    "${opcion}"=="Excepciones"
        IF    "${subseccion}"=="Tipo de excepciones - Rango"
            ${TIPO}=    set variable    startRange
        END
    ELSE IF    "${opcion}" == "Acuerdos"
        IF    "${subseccion}" == "Oferta comercial"
            ${TIPO}=    set variable    value
        ELSE IF    "${subseccion}" == "Roles comisionistas"
            ${TIPO}=    set variable    partyRoleName
        ELSE IF    "${subseccion}" == "Asignacion de metas por criterios"
            ${TIPO}=    set variable    criteria
        END
    ELSE IF    "${opcion}" == "Insumos"
        IF    "${subseccion}" == "Detalle de fichero - campos"
            ${TIPO}=    set variable    fileField.identifier
        END

    ELSE IF    "${opcion}" == "Estructura de Comisión"
        IF    "${subseccion}" == "Comision periodica - Oferta comercial"
            ${TIPO}=    set variable    value
        ELSE IF    "${subseccion}" == "Comision periodica - Origen de comision"
            ${TIPO}=    set variable    value
        ELSE IF    "${subseccion}" == "Distribucion - Pago Condicionado"
            ${TIPO}=    set variable    value
        ELSE IF    "${subseccion}" == "Distribucion - Clawback"
            ${TIPO}=    set variable    value
        ELSE IF    "${subseccion}" == "Condiciones Alteran Distribución"
            ${TIPO}=    set variable    conceptDistributionPeriod
        ELSE IF    "${subseccion}" == "Rangos"
            ${TIPO}=    set variable    quantity
        END
    END
    [return]    ${TIPO}

Obtener identificador subentidad
    [Arguments]    ${opcion}    ${subseccion}    ${valores_subseccion}

    ${identificador}=    set variable    -
    IF    "${opcion}"=="Tipos de catálogo"
        IF    "${subseccion}"=="Atributo"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END
    ELSE IF    "${opcion}" == "Valores posibles"
        IF    "${subseccion}" == "Elemento"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END
    ELSE IF    "${opcion}" == "Conceptos"
        IF    "${subseccion}" == "Elemento"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END
    ELSE IF    "${opcion}" == "Equivalencias"
        IF    "${subseccion}" == "Elemento"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END
    ELSE IF    "${opcion}" == "Clase Ubigeo"
        IF    "${subseccion}" == "Estructura"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END

    ELSE IF    "${opcion}" == "Impuestos"
        IF    "${subseccion}" == "Tasa"
            ${identificador}=    get from list    ${valores_subseccion}    2
        END

    ELSE IF    "${opcion}" == "Gestor Agentes - Organización"
        IF    "${subseccion}" == "Detalle"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Segmentos"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END

    ELSE IF    "${opcion}" == "Repositorios"
        IF    "${subseccion}" == "Conexion insumo"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END

    ELSE IF    "${opcion}" == "Plan de comision"
        IF    "${subseccion}" == "Estructuras de comision"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Estructuras de bonificacion"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END

    ELSE IF    "${opcion}" == "Penalidades"
        IF    "${subseccion}" == "Origen de la penalidad"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Item de Condición"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Reglas de calculo de penalidad"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Rango de condicion"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END

    ELSE IF    "${opcion}" == "Calendario"
        IF    "${subseccion}" == "Dia de Semana"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Excepciones"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END

    ELSE IF    "${opcion}" == "Intervalo"
        IF    "${subseccion}" == "Condicion"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Rango"
            ${identificador}=    get from list    ${valores_subseccion}    2
        END

    ELSE IF    "${opcion}" == "Matriz de puntos"
        IF    "${subseccion}" == "Elementos de la matriz"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Distribucion de puntos"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END

    ELSE IF    "${opcion}" == "Excepciones"
        IF    "${subseccion}" == "Origen de excepción"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Item de evaluación"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Tipo de excepciones"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Tipo de excepciones - Rango"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END

    ELSE IF    "${opcion}" == "Acuerdos"
        IF    "${subseccion}" == "Oferta comercial"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Roles comisionistas"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Asignacion de metas por criterios"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END

    ELSE IF    "${opcion}" == "Acuerdos"
        IF    "${subseccion}" == "Oferta comercial"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Roles comisionistas"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Asignacion de metas por criterios"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END

    ELSE IF    "${opcion}" == "Insumos"
        IF    "${subseccion}" == "Detalle de fichero - estructura"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Detalle de fichero - campos"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Enlace"
            ${identificador}=    get from list    ${valores_subseccion}    1
        END

    ELSE IF    "${opcion}" == "Estructura de Comisión"
        IF    "${subseccion}" == "Oferta Comercial"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Criterio de verificación"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Rol al que aplica"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Origen de la comisión"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Criterios de la meta"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Item de Condición"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Cumplimiento"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Condiciones para el cálculo de meta"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Rangos"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Selección de distribucion"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Comision periodica"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Comision periodica - Oferta comercial"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Comision periodica - Origen de comision"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Distribucion"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Distribucion - Pago Condicionado"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Distribucion - Clawback"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Distribucion - Condiciones Clawback"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Condiciones Alteran Distribución - E"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Condiciones Alteran Distribución"
            ${identificador}=    get from list    ${valores_subseccion}    2
        END
    END

    [return]    ${identificador}

Obtener identificador2 subentidad
    [Arguments]    ${opcion}    ${subseccion}    ${valores_subseccion}

    ${identificador}=    set variable    -
    IF    "${opcion}"=="Excepciones"
        IF    "${subseccion}" == "Tipo de excepciones - Rango"
            ${identificador}=    get from list    ${valores_subseccion}    2
        END
    ELSE IF    "${opcion}" == "Acuerdos"
        IF    "${subseccion}" == "Oferta comercial"
            ${identificador}=    get from list    ${valores_subseccion}    2
        ELSE IF    "${subseccion}" == "Roles comisionistas"
            ${identificador}=    get from list    ${valores_subseccion}    2
        ELSE IF    "${subseccion}" == "Asignacion de metas por criterios"
            ${identificador}=    get from list    ${valores_subseccion}    2
        END

    ELSE IF    "${opcion}" == "Insumos"
        IF    "${subseccion}" == "Detalle de fichero - campos"
            ${identificador}=    get from list    ${valores_subseccion}    2
        END

    ELSE IF    "${opcion}" == "Estructura de Comisión"
        IF    "${subseccion}" == "Comision periodica - Oferta comercial"
            ${identificador}=    get from list    ${valores_subseccion}    2
        ELSE IF    "${subseccion}" == "Comision periodica - Origen de comision"
            ${identificador}=    get from list    ${valores_subseccion}    2
        ELSE IF    "${subseccion}" == "Distribucion - Pago Condicionado"
            ${identificador}=    get from list    ${valores_subseccion}    2
        ELSE IF    "${subseccion}" == "Distribucion - Clawback"
            ${identificador}=    get from list    ${valores_subseccion}    2
        ELSE IF    "${subseccion}" == "Condiciones Alteran Distribución"
            ${identificador}=    get from list    ${valores_subseccion}    1
        ELSE IF    "${subseccion}" == "Rangos"
            ${identificador}=    get from list    ${valores_subseccion}    3
        END
    END

    [return]    ${identificador}
Obtener ID - CAMPOS CATALOGOS
    [Arguments]    ${datos_API}    ${nombre_campo_json}

    ${lista_id}=    get value from json    ${datos_API}    catalogType.characteristicSpecificationBeanList[*].${nombre_campo_json}
#    log to console    ${lista_id}

    [return]    ${lista_id}

Obtener JSON - CAMPOS CATALOGOS
    [Arguments]    ${datos_catalogo}    ${lista_id}    ${lista_campos}    ${valor_identificador}    ${UBICACION}

    ${n_datos}=    get length    ${datos_catalogo}
    ${n_ID}=    get length    ${lista_id}
    ${n_CAMPOS}=    get length    ${lista_campos}

    ${identificador}=    get from list    ${lista_id}    ${UBICACION}
#    log to console    N CATALOGO: ${n_datos}
#    log to console    IDENTIFICADOR: ${identificador}
    ${JSON_CAMPOS}=    set variable    -

    FOR    ${i}    IN RANGE    0    ${n_datos}
#        log to console    DATOS CATALOGO: ${datos_catalogo}[${i}]
        ${list}=    get from list    ${datos_catalogo}    ${i}
        ${string}=    convert to string    ${list}
#        log to console    DATOS CATALOGO STRING: ${string}
        ${json}=    modificar comillas    ${string}
#        log to console    DATOS CATALOGO STRING MODIFICADO: ${json}
        ${tipo}=    mostrar tipo    ${json}
#        log to console    ${tipo}
#        ${json}=    convert string to json    ${string2}
#        log to console    DATOS CATALOGO JSON: ${json}
        ${ident}=    convert to string    ${identificador}
#        log to console    IDENTIFICADOR JSON: ${ident}
        ${ID}=    get value from json    ${json}    '${ident}'
#        log to console    ID: ${ID}
        IF    "${ID}[0]" == "${valor_identificador}"
            ${JSON_CAMPOS}=    set variable    ${json}
            BREAK
        END
    END

    log to console    JSON DEL CAMPO: ${JSON_CAMPOS}

    [return]    ${JSON_CAMPOS}

Obtener VALOR - CAMPOS CATALOGOS
    [Arguments]    ${datos_catalogo}    ${lista_id}    ${lista_campos}    ${campo}

#    log to console    Campos: ${lista_campos}
#    log to console    Campo: ${campo}
#    log to console    JSON: ${datos_catalogo}

    ${n_datos}=    get length    ${datos_catalogo}
    ${n_ID}=    get length    ${lista_id}
    ${n_CAMPOS}=    get length    ${lista_campos}

    FOR    ${i}    IN RANGE    0    ${n_CAMPOS}
#        log to console    ${lista_campos}[${i}]
        IF    "${campo}" == "${lista_campos}[${i}]"
            ${ubicacion}=    set variable    ${i}
            BREAK
        ELSE IF    (("${campo}" == "Descripcion") and ("Descripción" == "${lista_campos}[${i}]")) or (("${campo}" == "Descripción") and ("Descripcion" == "${lista_campos}[${i}]"))
            ${ubicacion}=    set variable    ${i}
            BREAK
        ELSE
            ${ubicacion}=    set variable    -
        END
    END

#    log to console    UBICACION: ${ubicacion}

    IF    "${ubicacion}" != "-"
        ${ID_CAMPO}=    get from list    ${lista_id}    ${ubicacion}
        ${VALOR}=    get value from json    ${datos_catalogo}    '${ID_CAMPO}'
    ELSE
        ${VALOR}=    set variable    -
    END

#    log to console    ${VALOR}
    [return]    ${VALOR}

Obtener identificador - CATALOGOS
    [Arguments]    ${lista_campos_json}    ${campos_excel}

    ${n_CAMPOS_EXCEL}=    get length    ${campos_excel}
    ${n_CAMPOS_JSON}=    get length    ${lista_campos_json}

    IF    "${campos_excel}[0]" == "Descripción"
        ${campo}=    set variable    Descripcion
    ELSE
        ${campo}=    get from list    ${campos_excel}    0
    END

#    log to console    ${campo}

    ${UBICACION_LISTA}=    set variable    -

    FOR    ${i}    IN RANGE    0    ${n_CAMPOS_JSON}
        IF    "${campo}" == "${lista_campos_json}[${i}]"
            ${UBICACION_LISTA}=    set variable    ${i}
            BREAK
        END
    END

    [return]    ${UBICACION_LISTA}


Obtener JSON - EXCEPCIONES
    [Arguments]    ${lista_json}    ${valores_excel}

    ${JSON}=    set variable    -

    IF    "${lista_json}" != "-"
        ${n_lista_json}=    get length    ${lista_json}
        FOR    ${i}    IN RANGE    0    ${n_lista_json}
            ${json_actual}=    get from list    ${lista_json}    ${i}
            @{descripcion}=    get value from json    ${json_actual}    description
            @{Tipo_excepcion}=    get value from json    ${json_actual}    calendarExceptionType
            @{Tipo_frecuencia}=    get value from json    ${json_actual}    frequencyType
            ${desc}=    get from list    ${descripcion}    0
            ${excep}=    get from list    ${Tipo_excepcion}    0
            ${frec}=    get from list    ${Tipo_frecuencia}    0

            ${descripcion_excel}=    get from list    ${valores_excel}    1
            ${tipo_excel}=    get from list    ${valores_excel}    2
            ${tipo_excel}=    modificar valor excel    ${tipo_excel}    Tipo
            ${frecuencia_excel}=    get from list    ${valores_excel}    3
            ${frecuencia_excel}=    modificar valor excel    ${frecuencia_excel}    Frecuencia

            IF    ("${descripcion_excel}"=="${desc}") and ("${tipo_excel}"=="${excep}") and ("${frecuencia_excel}"=="${frec}")
                ${JSON}=    set variable    ${json_actual}
                BREAK
            END
        END
    END

    [return]    ${JSON}

Obtener data - rango intervalo
    [Arguments]    ${ID}

    &{header}=    create dictionary    Content-Type=application/json    Authorization=${TOKEN}
    ${API}=    set variable    /service/config-service/interval-condition/${ID}/ranges

    IF    ("${ID}" == "-") or ("${ID}" == "-&-")
        ${valor_json}=    set variable    -
    ELSE
        ${valor}=    get request    ${session}    ${API}    headers=${header}
        ${valor_string}=    convert to string    ${valor.content}
#        log to console    CONTENIDO DEL VALOR EN STRING: ${valor_string}
        ${valor_string2}=    cambiarCaracterUTF8    ${valor_string}
#        log to console    CONTENIDO DEL VALOR EN STRING DESPUES DE FUNCION: ${valor_string2}
        ${valor_json}=    convert string to json    ${valor_string2}
#        log to console    CONTENIDO DEL VALOR EN JSON: ${valor_json}
        ${n_valor_json}=    get length    ${valor_json}

    END
    [return]    ${valor_json}

Obtener identificador - matriz dist puntos
    [Arguments]    ${JSON}    ${elementos_excel}

    @{Lista_elementos}=    create list
    @{JSON_combination_item}=    get value from json    ${JSON}    pointMatrixCombinationItemList[*]
#    log to console    Combinacion: ${JSON_combination_item}
    ${n_JSON}=    get length    ${JSON_combination_item}

    FOR    ${i}    IN RANGE    0    ${n_JSON}
        ${json_actual}=    get from list    ${JSON_combination_item}    ${i}
        @{valor_actual}=    get value from json    ${json_actual}    description
        ${valor}=    get from list    ${valor_actual}    0
        append to list    ${Lista_elementos}    ${valor}
    END

    ${n_lista_combinacion}=    get length    ${Lista_elementos}
#    log to console    LISTA API: ${Lista_elementos}
#    log to console    LISTA EXCEL: ${elementos_excel}
    ${resultado}=    elemento API esta en Lista elemento EXCEL    ${Lista_elementos}    ${elementos_excel}
#    log to console    ${resultado}

    IF    ("${resultado}"=="True")
#        log to console    LISTA API: ${Lista_elementos}
#        log to console    LISTA EXCEL: ${elementos_excel}

        @{id_actual}=    get value from json    ${JSON}    id
        ${id}=    get from list    ${id_actual}    0
    ELSE
        ${id}=    set variable    -
    END

#    log to console    ${id}
    [return]    ${id}

Obtener ID - plan acuerdo
    [Arguments]    ${data_json}

#    log to console    ${data_json}
    IF    "${data_json}" != "-"
        @{valor}=    get value from json    ${data_json}    agreementVersion.planVersionId
        ${id}=    get from list    ${valor}    0
    ELSE
        ${id}=    set variable    -
    END

    log to console    ${id}
    [return]    ${id}

MODIFICAR ID ESTRUCTURA
    [Arguments]    ${json_plan}    ${nombre_estructura}

    ${id}=    set variable    -

    @{data_plan}=    get value from json    ${json_plan}    planVersion.planConceptList
    @{lista_estructuras_plan}=    get from list    ${data_plan}    0
#    log to console    DATOS DEL PLAN: ${lista_estructuras_plan}
    ${n_data_plan}=    get length    ${lista_estructuras_plan}
#    log to console    CANTIDAD DE ESTRUCTURAS DENTRO DEL PLAN: ${n_data_plan}
    FOR    ${i}    IN RANGE    0    ${n_data_plan}
        @{tipo_estructura}=    get value from json    ${lista_estructuras_plan}[${i}]    type
        ${tipo}=    get from list    ${tipo_estructura}    0
#        log to console    TIPO DE ESTRUCTURA: ${tipo}
        IF    "${tipo}"=="C"
            @{nombre_estructura_API}=    get value from json    ${lista_estructuras_plan}[${i}]    commissionStructureVersion.description
            ${nombre}=    get from list    ${nombre_estructura_API}    0
#            log to console    NOMBRE DE ESTRUCTURA: ${nombre}
            IF    "${nombre}" == "${nombre_estructura}"
                @{id_estructura}=    get value from json    ${lista_estructuras_plan}[${i}]    id
                ${id}=    get from list    ${id_estructura}    0
                BREAK
            END
        ELSE
            @{nombre_estructura_API}=    get value from json    ${data_plan}[${i}]    bonusPlanVersion.description
            ${nombre}=    get from list    ${nombre_estructura_API}    0
#            log to console    NOMBRE DE ESTRUCTURA: ${nombre}
            IF    "${nombre}" == "${nombre_estructura}"
                @{id_estructura}=    get value from json    ${data_plan}[${i}]    id
                ${id}=    get from list    ${id_estructura}    0
                BREAK
            END
        END
    END

#    log to console    ID DE ESTRUCTURA: ${id}
    [return]    ${id}

Modificar identificador - tipo de criterio
    [Arguments]    ${json}

    ${tipo}=    set variable    -

    @{data}=    get value from json    ${json}    valueType
    ${tipo_valor}=    get from list    ${data}    0
    IF    "${tipo_valor}" == "C"
        ${tipo}=    set variable    itemCatalog
    ELSE IF    "${tipo_valor}" == "O"
        ${tipo}=    set variable    value
    END

#    log to console    TIPO DE ESTRUCTURA: ${id}
    [return]    ${tipo}


OBTENER API
    [Arguments]    ${opcion}    ${seccion}

    ${API}=    set variable    -

    IF    "${opcion}" == "Valores posibles"
        ${API}=    set variable    /service/config-service/possible-value
    ELSE IF    "${opcion}" == "Ciclos de Liquidacion"
        ${API}=    set variable    /service/config-service/billing-cycle
    ELSE IF    "${opcion}" == "Clase Ubigeo"
        ${API}=    set variable    /service/config-service/class-ubigeo
    ELSE IF    "${opcion}" == "Impuestos"
        ${API}=    set variable    /service/config-service/tax
    ELSE IF    "${opcion}" == "Tipos de catálogo"
        ${API}=    set variable    /service/config-service/catalog-type
    ELSE IF    "${opcion}" == "Catalogos"
        IF    "${seccion}" == "Encabezado"
            ${API}=    set variable    /service/config-service/catalog
        ELSE
            ${API}=    set variable    /service/config-service/characteristic-value/list-value-group-pagination
        END
    ELSE IF    "${opcion}" == "Gestor Agentes - Individuos"
        ${API}=    set variable    /service/config-service/party

    END

    [return]    ${API}