*** Settings ***
Library    RequestsLibrary
Library    JSONLibrary
Library    Collections
Library    SeleniumLibrary

Resource    ../Funciones/FuncionesRobot/FuncionesAPI.robot

Resource    ../Componentes/MenuAgentes/Roles.robot
Resource    ../Componentes/MenuAgentes/Individuos.robot
Resource    ../Componentes/MenuAgentes/Organizaciones.robot

Library    ../Funciones/FuncionesPython/LecturaExcel.py
Library    ../Funciones/FuncionesPython/FuncionesReporte.py

Variables    ../Variables/variables.py

*** Variables ***


*** Test Cases ***
TC VALIDACION DEL MENU DE CONFIGURACION

    Create Session    ${session}    ${URL_TOKEN}

    &{header}=    create dictionary    Content-Type=application/x-www-form-urlencoded    Cookie=KEYCLOAK_LOCALE=es
    &{body}=    create dictionary    grant_type=password    client_id=bcom-backend    client_secret=${client_secret}    username=${username}    password=${password}

    log to console    ${header}
    log to console    ${body}

    ${resp}=    Post Request    ${session}    /auth/realms/BCOM/protocol/openid-connect/token    headers=${header}    data=${body}
    log to console    ${resp}

    ${token1}=    Collections.Get From Dictionary    ${resp.json()}    access_token
    ${token2}=    Collections.Get From Dictionary    ${resp.json()}    refresh_token

    log to console    ${token1}
    log to console    ${token2}